/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common;

@SuppressWarnings("serial")
public class BacklevelClientRuntimeException extends RuntimeException {
    private String unknownClassName;
    private String requiredClientVersion;

    public BacklevelClientRuntimeException(String message, String unknownClassName,
            String requiredClientVersion) {
        super(message);
        this.unknownClassName = unknownClassName;
        this.requiredClientVersion = requiredClientVersion;
    }

    public String getUnknownClassName() {
        return unknownClassName;
    }

    public String getRequiredClientVersion() {
        return requiredClientVersion;
    }
}
