/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;

import com.ibm.team.repository.common.internal.nls.Messages;
import com.ibm.team.repository.common.util.NLS;

/**
 * @since 0.6 M2
 */
public class ContentNotFound extends TeamRepositoryException {
    private static final long serialVersionUID = -2357015528420315825L;

    private static final String REPOSITORY_CONTENT_NOT_FOUND = Messages.getServerString("ContentNotFound.ERROR_CONTENT_NOT_FOUND"); //$NON-NLS-1$
    
    public ContentNotFound(UUID contentId, Throwable cause) {
        super(NLS.bind(REPOSITORY_CONTENT_NOT_FOUND, contentId), cause);
        super.setData(contentId);
    }

    public ContentNotFound(UUID contentId) {
        super(NLS.bind(REPOSITORY_CONTENT_NOT_FOUND, contentId));
        super.setData(contentId);
    }

    public ContentNotFound(IContent content, Throwable cause) {
        super(NLS.bind(REPOSITORY_CONTENT_NOT_FOUND, content), cause);
        super.setData(content);
    }

    public ContentNotFound(IContent content) {
        super(NLS.bind(REPOSITORY_CONTENT_NOT_FOUND, content));
        super.setData(content);
    }
}