/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

package com.ibm.team.repository.common;


/**
 * Thrown when a repository operation detects two duplicate userids.
 * 
 * This can happen when the server is configured to be case insensitive, and the
 * database contains two userids that differ only by case.  (A server in this
 * state is considered to be broken.) */
public class DuplicateUserIdException extends TeamRepositoryException {

	private static final long serialVersionUID = -2092195956149980984L;

	public DuplicateUserIdException(String message) {
		super(message);
	}
}
