/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;

import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.METHOD;
import static java.lang.annotation.ElementType.PACKAGE;
import static java.lang.annotation.ElementType.TYPE;

import java.lang.annotation.Target;


/**
 * Identifies code needed for N-1 compatability.
 * 
 * If used correctly, can be used to identify code that can be removed when new 
 *  major releases occur.
 *  
 * Typical usage is to annotation classes and methods with an annotation like <code>@ForVersion("3.0")</code>.
 */
@Target({TYPE,FIELD,METHOD,PACKAGE})
public @interface ForVersion {
    public String value();
}
