/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common;

import org.eclipse.emf.ecore.EStructuralFeature;

import com.ibm.team.repository.common.model.Item;

public interface IConfigurationAwareItem extends IConfigurationAwareItemHandle, IManagedItem, Item {

	/**
	 * Sets the collection id for the given feature.  This method is for
	 * internal use only.
	 */
	public void setCollectionIdForFeature(EStructuralFeature feature, UUID collectionId);

	/**
	 * Retrieves the collection id for the given feature.  This method is for
	 * internal use only.
	 */
	public UUID getCollectionIdForFeature(EStructuralFeature feature);

	/**
	 * Sets the collection id for a particular contained helper.  This method is
	 * for internal user only.
	 */
	public void setCollectionIdForContainedHelper(UUID internalId, EStructuralFeature feature, UUID collectionId);

	/**
	 * Gets the collection id for a particular contained helper.  This method is
	 * for internal user only.
	 */
	public UUID getCollectionIdForContainedHelper(UUID internalId, EStructuralFeature feature);
}
