/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;


/**
 * @since 1.0.0.1
 */
public interface IDefaultLicenseProviderService {
    
    /**
     * Get the license id to be assigned to the user during LDAP import.
     *  
     * @return the license to be assigned to user records imported from LDAP
     * @throws TeamRepositoryException if anything goes wrong
     * @deprecated Use {@link #getDefaultLicenseIds()} instead.
     */
    public String getDefaultLicenseId() throws TeamRepositoryException;
    
    /**
     * Gets the license ids to be assigned to the user during LDAP import.
     * @return the licenses to be assigned to user records imported from LDAP. Does not return {@code null}.
     * Returns an empty array if there are no default licenses.
     * @throws TeamRepositoryException if anything goes wrong
     * @since 4.0
     */
    public String[] getDefaultLicenseIds() throws TeamRepositoryException;
}
