/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;

/**
 * Transient object used for querying groups from an external user registry 
 * (e.g. LDAP).
 * 
 * @NoImplement
 * @since 0.6
 */
public interface IExternalGroup {
    
    /**
     * Get the name of the group
     */
    String getName();
    
    /**
     * Get the description of the group
     */
    String getDescription();
}
