/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;

import java.util.List;

/**
 * Transient object for returning any group-to-role mapping in a JTS for a user registry.
 *
 * @NoImplement
 */
public interface IExternalGroupToRoleMapping {

    /**
     * Get the name of the external group.
     */
    String getGroupName();
    
    /**
     * Get the security roles mapped to the external group.
     */
    List getRoles();
}
