/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;

public interface IManagedItem extends IItem, IManagedItemHandle {
    
    /**
     * Returns whether this item is a working copy for a brand new item.
     * 
     * @return <code>true</code> if this is a working copy for a brand new
     *         item, and <code>false</code> if this is either a working copy
     *         for updating an existing item, or is not a working copy
     * @ShortOp This is a short operation; it may block only momentarily; safe
     *          to call from a responsive thread.
     */
    public boolean isNewItem();

}
