/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;

public interface IServerContainerProvider {
    /**
     * Start the provider.  The specifics of starting a provider is
     * implementation defined.
     * 
     * @throws Exception
     */
    public void start() throws Exception;
    
    /**
     * Stop the provider.  The specifics of stopping a provider is
     * implementation defined.
     * 
     * @throws Exception
     */
    public void stop() throws Exception;
}
