/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common;


public interface IServerLicenseType extends ILicenseType {

    /**
     * Returns the maximum number of unique users that can 
     * have licenses assigned on this server.  A single user that has  
     * multiple CALs assigned, only counts as one user towards 
     * the server limit.
     * 
     * @return the maximum number of unique users that can 
     *         have licenses assigned on this server.
     */
    public int getMaxContributors();
    
    /**
     * Returns the current number of unique users that have licenses 
     * assigned on this server.  A single user that has multiple
     * CALs assigned, only counts as one user towards the server limit.
     * 
     * @return the current number of unique users that have licenses
     *         assigned on this server.
     */    
    public int getUsedContributors();


}
