/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal;

import org.eclipse.emf.ecore.EFactory;

import com.ibm.team.repository.common.transport.internal.services.DataArgType;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.ibm.team.repository.common.internal.marshal.MarshalPackage
 * @generated
 */
public interface MarshalFactory extends EFactory {
    /**
     * The singleton instance of the factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    MarshalFactory eINSTANCE = com.ibm.team.repository.common.internal.marshal.impl.MarshalFactoryImpl.init();

    /**
     * Returns the package supported by this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the package supported by this factory.
     * @generated
     */
    MarshalPackage getMarshalPackage();

    /**
     * Get the marshaller given the class
     */
    Marshaller getMarshaller(Class classZ);
    
    /**
     * Get the marshaller given the type.. 
     */
    Marshaller getMarshaller(MarshallerType marshallerType);
    
    /**
     * Get the marshaller given the data arg type
     */
    Marshaller getMarshaller(DataArgType dataArgType);
} //MarshalFactory