/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.team.repository.common.internal.marshal.MarshalFactory
 * @model kind="package"
 * @generated
 */
public interface MarshalPackage extends EPackage {
    /**
     * The package name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNAME = "marshal"; //$NON-NLS-1$

    /**
     * The package namespace URI.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_URI = "com.ibm.team.common.marshaller"; //$NON-NLS-1$

    /**
     * The package namespace name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_PREFIX = "marshaller"; //$NON-NLS-1$

    /**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    MarshalPackage eINSTANCE = com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl.init();

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.internal.marshal.impl.MarshallerImpl <em>Marshaller</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.internal.marshal.impl.MarshallerImpl
     * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getMarshaller()
     * @generated
     */
    int MARSHALLER = 1;

    /**
     * The feature id for the '<em><b>Marshaller Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MARSHALLER__MARSHALLER_TYPE = 0;

    /**
     * The feature id for the '<em><b>Supported Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MARSHALLER__SUPPORTED_TYPE = 1;

    /**
     * The number of structural features of the '<em>Marshaller</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MARSHALLER_FEATURE_COUNT = 2;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.internal.marshal.impl.ComplexTypeMarshallerImpl <em>Complex Type Marshaller</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.internal.marshal.impl.ComplexTypeMarshallerImpl
     * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getComplexTypeMarshaller()
     * @generated
     */
    int COMPLEX_TYPE_MARSHALLER = 0;

    /**
     * The feature id for the '<em><b>Marshaller Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_TYPE_MARSHALLER__MARSHALLER_TYPE = MARSHALLER__MARSHALLER_TYPE;

    /**
     * The feature id for the '<em><b>Supported Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_TYPE_MARSHALLER__SUPPORTED_TYPE = MARSHALLER__SUPPORTED_TYPE;

    /**
     * The number of structural features of the '<em>Complex Type Marshaller</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_TYPE_MARSHALLER_FEATURE_COUNT = MARSHALLER_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.internal.marshal.impl.PrimitiveTypeMarshallerImpl <em>Primitive Type Marshaller</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.internal.marshal.impl.PrimitiveTypeMarshallerImpl
     * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getPrimitiveTypeMarshaller()
     * @generated
     */
    int PRIMITIVE_TYPE_MARSHALLER = 2;

    /**
     * The feature id for the '<em><b>Marshaller Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_TYPE_MARSHALLER__MARSHALLER_TYPE = MARSHALLER__MARSHALLER_TYPE;

    /**
     * The feature id for the '<em><b>Supported Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_TYPE_MARSHALLER__SUPPORTED_TYPE = MARSHALLER__SUPPORTED_TYPE;

    /**
     * The number of structural features of the '<em>Primitive Type Marshaller</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_TYPE_MARSHALLER_FEATURE_COUNT = MARSHALLER_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.internal.marshal.MarshallerType <em>Marshaller Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.internal.marshal.MarshallerType
     * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getMarshallerType()
     * @generated
     */
    int MARSHALLER_TYPE = 3;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.internal.marshal.MarshallingExceptionReasonCode <em>Marshalling Exception Reason Code</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.internal.marshal.MarshallingExceptionReasonCode
     * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getMarshallingExceptionReasonCode()
     * @generated
     */
    int MARSHALLING_EXCEPTION_REASON_CODE = 4;


    /**
     * The meta object id for the '<em>Class</em>' data type.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see java.lang.Class
     * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getClass_()
     * @generated
     */
    int CLASS = 5;


    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.internal.marshal.ComplexTypeMarshaller <em>Complex Type Marshaller</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Complex Type Marshaller</em>'.
     * @see com.ibm.team.repository.common.internal.marshal.ComplexTypeMarshaller
     * @generated
     */
    EClass getComplexTypeMarshaller();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.internal.marshal.Marshaller <em>Marshaller</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Marshaller</em>'.
     * @see com.ibm.team.repository.common.internal.marshal.Marshaller
     * @generated
     */
    EClass getMarshaller();

    /**
     * Returns the meta object for the attribute '{@link com.ibm.team.repository.common.internal.marshal.Marshaller#getMarshallerType <em>Marshaller Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Marshaller Type</em>'.
     * @see com.ibm.team.repository.common.internal.marshal.Marshaller#getMarshallerType()
     * @see #getMarshaller()
     * @generated
     */
    EAttribute getMarshaller_MarshallerType();

    /**
     * Returns the meta object for the attribute '{@link com.ibm.team.repository.common.internal.marshal.Marshaller#getSupportedType <em>Supported Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Supported Type</em>'.
     * @see com.ibm.team.repository.common.internal.marshal.Marshaller#getSupportedType()
     * @see #getMarshaller()
     * @generated
     */
    EAttribute getMarshaller_SupportedType();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.internal.marshal.PrimitiveTypeMarshaller <em>Primitive Type Marshaller</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Primitive Type Marshaller</em>'.
     * @see com.ibm.team.repository.common.internal.marshal.PrimitiveTypeMarshaller
     * @generated
     */
    EClass getPrimitiveTypeMarshaller();

    /**
     * Returns the meta object for enum '{@link com.ibm.team.repository.common.internal.marshal.MarshallerType <em>Marshaller Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Marshaller Type</em>'.
     * @see com.ibm.team.repository.common.internal.marshal.MarshallerType
     * @generated
     */
    EEnum getMarshallerType();

    /**
     * Returns the meta object for enum '{@link com.ibm.team.repository.common.internal.marshal.MarshallingExceptionReasonCode <em>Marshalling Exception Reason Code</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Marshalling Exception Reason Code</em>'.
     * @see com.ibm.team.repository.common.internal.marshal.MarshallingExceptionReasonCode
     * @generated
     */
    EEnum getMarshallingExceptionReasonCode();

    /**
     * Returns the meta object for data type '{@link java.lang.Class <em>Class</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for data type '<em>Class</em>'.
     * @see java.lang.Class
     * @model instanceClass="java.lang.Class"
     * @generated
     */
    EDataType getClass_();

    /**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
    MarshalFactory getMarshalFactory();

    /**
     * <!-- begin-user-doc -->
     * Defines literals for the meta objects that represent
     * <ul>
     *   <li>each class,</li>
     *   <li>each feature of each class,</li>
     *   <li>each enum,</li>
     *   <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("hiding")
    interface Literals  {
        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.internal.marshal.impl.ComplexTypeMarshallerImpl <em>Complex Type Marshaller</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.internal.marshal.impl.ComplexTypeMarshallerImpl
         * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getComplexTypeMarshaller()
         * @generated
         */
		EClass COMPLEX_TYPE_MARSHALLER = eINSTANCE.getComplexTypeMarshaller();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.internal.marshal.impl.MarshallerImpl <em>Marshaller</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.internal.marshal.impl.MarshallerImpl
         * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getMarshaller()
         * @generated
         */
        EClass MARSHALLER = eINSTANCE.getMarshaller();

        /**
         * The meta object literal for the '<em><b>Marshaller Type</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute MARSHALLER__MARSHALLER_TYPE = eINSTANCE.getMarshaller_MarshallerType();

        /**
         * The meta object literal for the '<em><b>Supported Type</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute MARSHALLER__SUPPORTED_TYPE = eINSTANCE.getMarshaller_SupportedType();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.internal.marshal.impl.PrimitiveTypeMarshallerImpl <em>Primitive Type Marshaller</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.internal.marshal.impl.PrimitiveTypeMarshallerImpl
         * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getPrimitiveTypeMarshaller()
         * @generated
         */
        EClass PRIMITIVE_TYPE_MARSHALLER = eINSTANCE.getPrimitiveTypeMarshaller();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.internal.marshal.MarshallerType <em>Marshaller Type</em>}' enum.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.internal.marshal.MarshallerType
         * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getMarshallerType()
         * @generated
         */
        EEnum MARSHALLER_TYPE = eINSTANCE.getMarshallerType();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.internal.marshal.MarshallingExceptionReasonCode <em>Marshalling Exception Reason Code</em>}' enum.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.internal.marshal.MarshallingExceptionReasonCode
         * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getMarshallingExceptionReasonCode()
         * @generated
         */
        EEnum MARSHALLING_EXCEPTION_REASON_CODE = eINSTANCE.getMarshallingExceptionReasonCode();

        /**
         * The meta object literal for the '<em>Class</em>' data type.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see java.lang.Class
         * @see com.ibm.team.repository.common.internal.marshal.impl.MarshalPackageImpl#getClass_()
         * @generated
         */
        EDataType CLASS = eINSTANCE.getClass_();

    }

} //MarshalPackage
