/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.internal.marshal.MarshallingException;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;

/**
 * Marshaler to marshal a Boolean object
 */
public class BooleanMarshaller extends PrimitiveTypeMarshallerImpl {

    public BooleanMarshaller() {
        super();
        setSupportedType(Boolean.TYPE);
        setMarshallerType(MarshallerType.BOOLEAN_LITERAL);
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.BOOLEAN_LITERAL;
    }
    
    @Override
    public Object marshalAttributeValue(Object object) throws MarshallingException {
        // object will be Boolean
        return object;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        return Boolean.valueOf(((PrimitiveDataArg)dataArg).getValue());
    }

    public Object demarshalObjectFromString(String value) {
        return Boolean.valueOf(value);
    }
}