/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;

public class ByteMarshaller extends PrimitiveTypeMarshallerImpl {

    public ByteMarshaller() {
        super();
        setSupportedType(Byte.TYPE);
        setMarshallerType(MarshallerType.BYTE_LITERAL);
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.BYTE_LITERAL;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        String stringValue = ((PrimitiveDataArg)dataArg).getValue();
        if(stringValue == null) {
            return null;
        }
        return Byte.valueOf(stringValue);
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.marshal.PrimitiveTypeMarshaller#demarshalObjectObjectFromString(java.lang.String)
     */
    public Object demarshalObjectFromString(String value) {
        return Byte.valueOf(value);
    }

}
