/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.util.EcoreUtil;

import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.internal.marshal.MarshallingException;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;

public class CharacterMarshaller extends PrimitiveTypeMarshallerImpl {

    public CharacterMarshaller() {
        super();
        setSupportedType(Character.TYPE);
        setMarshallerType(MarshallerType.CHARACTER_LITERAL);
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.CHARACTER_LITERAL;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        String stringValue = ((PrimitiveDataArg)dataArg).getValue();
        if(stringValue == null) {
            return null;
        }
        return Character.valueOf(stringValue.charAt(0));
    }

    public Object demarshalObjectFromString(String value) {
    	return EcoreUtil.createFromString(EcorePackage.eINSTANCE.getECharacterObject(), value);
    }
    
    @Override
    public String marshalObjectToString(Object object) throws MarshallingException {
    	return EcoreUtil.convertToString(EcorePackage.eINSTANCE.getECharacterObject(), object);
    }

}
