/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import java.util.Map;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.ibm.team.repository.common.internal.marshal.ComplexTypeMarshaller;
import com.ibm.team.repository.common.internal.marshal.MarshalPackage;
import com.ibm.team.repository.common.transport.internal.services.ComplexDataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.ServicesFactory;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Complex Type Marshaller</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public abstract class ComplexTypeMarshallerImpl extends MarshallerImpl implements ComplexTypeMarshaller {
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ComplexTypeMarshallerImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EClass eStaticClass() {
        return MarshalPackage.Literals.COMPLEX_TYPE_MARSHALLER;
    }

    /**
     * <!-- begin-user-doc -->
     * @param dataArg 
     * @param sharedReferences 
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public void addSharedReferences(DataArg dataArg, Map sharedReferences) {
        
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.COMPLEX_LITERAL;
    }
    
    /**
     * Marshal object to data argument
     * @param object Object that need to be converted to data argument
     */
    public DataArg marshalObjectToDataArg(Object object) {
        ComplexDataArg complexDataArg = ServicesFactory.eINSTANCE.createComplexDataArg();
        complexDataArg.setType(DataArgType.COMPLEX_LITERAL);
        complexDataArg.setValue((EObject)object);
        return complexDataArg;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        return ((ComplexDataArg)dataArg).getValue();
    }
} //ComplexTypeMarshallerImpl
