/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.internal.marshal.MarshallingException;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;

public class FloatMarshaller extends PrimitiveTypeMarshallerImpl {

    public FloatMarshaller() {
        super();
        setMarshallerType(MarshallerType.FLOAT_LITERAL);
        setSupportedType(Float.TYPE);
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.FLOAT_LITERAL;
    }
    
    @Override
    public Object marshalAttributeValue(Object object) throws MarshallingException {
        return object;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        return Float.valueOf(((PrimitiveDataArg)dataArg).getValue());
    }

    public Object demarshalObjectFromString(String value) {
        return Float.valueOf(value);
    }
}
