/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.internal.marshal.impl;

import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.internal.marshal.MarshallingException;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;

/**
 * Marshaller to marshal a Long object
 */
public class LongMarshaller extends PrimitiveTypeMarshallerImpl {

    public LongMarshaller() {
        super();
        setSupportedType(Long.TYPE);
        setMarshallerType(MarshallerType.LONG_LITERAL);
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.LONG_LITERAL;
    }
    
    @Override
    public Object marshalAttributeValue(Object object) throws MarshallingException {
        return object;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        String stringValue = ((PrimitiveDataArg)dataArg).getValue();
        if(stringValue == null) {
            return null;
        }
        return Long.valueOf(stringValue);
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.marshal.PrimitiveTypeMarshaller#demarshalObjectObjectFromString(java.lang.String)
     */
    public Object demarshalObjectFromString(String value) {
        return Long.valueOf(value);
    }
}