/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import com.ibm.team.repository.common.internal.marshal.ComplexTypeMarshaller;
import com.ibm.team.repository.common.internal.marshal.MarshalFactory;
import com.ibm.team.repository.common.internal.marshal.MarshalPackage;
import com.ibm.team.repository.common.internal.marshal.Marshaller;
import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.internal.marshal.MarshallingExceptionReasonCode;
import com.ibm.team.repository.common.internal.marshal.PrimitiveTypeMarshaller;
import com.ibm.team.repository.common.transport.internal.services.ServicesPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MarshalPackageImpl extends EPackageImpl implements MarshalPackage {
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass complexTypeMarshallerEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass marshallerEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass primitiveTypeMarshallerEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EEnum marshallerTypeEEnum = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EEnum marshallingExceptionReasonCodeEEnum = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EDataType classEDataType = null;

    /**
     * Creates an instance of the model <b>Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
     * package URI value.
     * <p>Note: the correct way to create the package is via the static
     * factory method {@link #init init()}, which also performs
     * initialization of the package, or returns the registered package,
     * if one already exists.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see com.ibm.team.repository.common.internal.marshal.MarshalPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private MarshalPackageImpl() {
        super(eNS_URI, MarshalFactory.eINSTANCE);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static boolean isInited = false;

    /**
     * Creates, registers, and initializes the <b>Package</b> for this
     * model, and for any others upon which it depends.  Simple
     * dependencies are satisfied by calling this method on all
     * dependent packages before doing anything else.  This method drives
     * initialization for interdependent packages directly, in parallel
     * with this package, itself.
     * <p>Of this package and its interdependencies, all packages which
     * have not yet been registered by their URI values are first created
     * and registered.  The packages are then initialized in two steps:
     * meta-model objects for all of the packages are created before any
     * are initialized, since one package's meta-model objects may refer to
     * those of another.
     * <p>Invocation of this method will not affect any packages that have
     * already been initialized.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
    public static MarshalPackage init() {
        if (isInited) return (MarshalPackage)EPackage.Registry.INSTANCE.getEPackage(MarshalPackage.eNS_URI);

        // Obtain or create and register package
        MarshalPackageImpl theMarshalPackage = (MarshalPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof MarshalPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new MarshalPackageImpl());

        isInited = true;

        // Initialize simple dependencies
        ServicesPackage.eINSTANCE.eClass();

        // Create package meta-data objects
        theMarshalPackage.createPackageContents();

        // Initialize created meta-data
        theMarshalPackage.initializePackageContents();

        // Mark meta-data to indicate it can't be changed
        theMarshalPackage.freeze();

        return theMarshalPackage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getComplexTypeMarshaller() {
        return complexTypeMarshallerEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getMarshaller() {
        return marshallerEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getMarshaller_SupportedType() {
        return (EAttribute)marshallerEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getMarshaller_MarshallerType() {
        return (EAttribute)marshallerEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getPrimitiveTypeMarshaller() {
        return primitiveTypeMarshallerEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EEnum getMarshallerType() {
        return marshallerTypeEEnum;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EEnum getMarshallingExceptionReasonCode() {
        return marshallingExceptionReasonCodeEEnum;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EDataType getClass_() {
        return classEDataType;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public MarshalFactory getMarshalFactory() {
        return (MarshalFactory)getEFactoryInstance();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private boolean isCreated = false;

    /**
     * Creates the meta-model objects for the package.  This method is
     * guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void createPackageContents() {
        if (isCreated) return;
        isCreated = true;

        // Create classes and their features
        complexTypeMarshallerEClass = createEClass(COMPLEX_TYPE_MARSHALLER);

        marshallerEClass = createEClass(MARSHALLER);
        createEAttribute(marshallerEClass, MARSHALLER__MARSHALLER_TYPE);
        createEAttribute(marshallerEClass, MARSHALLER__SUPPORTED_TYPE);

        primitiveTypeMarshallerEClass = createEClass(PRIMITIVE_TYPE_MARSHALLER);

        // Create enums
        marshallerTypeEEnum = createEEnum(MARSHALLER_TYPE);
        marshallingExceptionReasonCodeEEnum = createEEnum(MARSHALLING_EXCEPTION_REASON_CODE);

        // Create data types
        classEDataType = createEDataType(CLASS);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model.  This
     * method is guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void initializePackageContents() {
        if (isInitialized) return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Obtain other dependent packages
        ServicesPackage theServicesPackage = (ServicesPackage)EPackage.Registry.INSTANCE.getEPackage(ServicesPackage.eNS_URI);

        // Add supertypes to classes
        complexTypeMarshallerEClass.getESuperTypes().add(this.getMarshaller());
        primitiveTypeMarshallerEClass.getESuperTypes().add(this.getMarshaller());

        // Initialize classes and features; add operations and parameters
        initEClass(complexTypeMarshallerEClass, ComplexTypeMarshaller.class, "ComplexTypeMarshaller", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$

        initEClass(marshallerEClass, Marshaller.class, "Marshaller", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEAttribute(getMarshaller_MarshallerType(), this.getMarshallerType(), "marshallerType", null, 0, 1, Marshaller.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
        initEAttribute(getMarshaller_SupportedType(), this.getClass_(), "supportedType", null, 0, 1, Marshaller.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        addEOperation(marshallerEClass, theServicesPackage.getDataArgType(), "getSupportedDataArgType", 0, 1); //$NON-NLS-1$

        addEOperation(marshallerEClass, ecorePackage.getEString(), "getRegistrationName", 0, 1); //$NON-NLS-1$

        EOperation op = addEOperation(marshallerEClass, ecorePackage.getEBoolean(), "canMarshal", 0, 1); //$NON-NLS-1$
        addEParameter(op, ecorePackage.getEJavaObject(), "object", 0, 1); //$NON-NLS-1$

        op = addEOperation(marshallerEClass, ecorePackage.getEBoolean(), "canMarshal", 0, 1); //$NON-NLS-1$
        addEParameter(op, this.getClass_(), "type", 0, 1); //$NON-NLS-1$

        op = addEOperation(marshallerEClass, theServicesPackage.getDataArg(), "marshalObjectToDataArg", 0, 1); //$NON-NLS-1$
        addEParameter(op, ecorePackage.getEJavaObject(), "object", 0, 1); //$NON-NLS-1$

        initEClass(primitiveTypeMarshallerEClass, PrimitiveTypeMarshaller.class, "PrimitiveTypeMarshaller", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$

        // Initialize enums and add enum literals
        initEEnum(marshallerTypeEEnum, MarshallerType.class, "MarshallerType"); //$NON-NLS-1$
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.PRIMITIVE_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.COMPLEX_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.VOID_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.CHARACTER_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.BYTE_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.STRING_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.INTEGER_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.SHORT_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.LONG_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.FLOAT_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.DOUBLE_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.BOOLEAN_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.TIMESTAMP_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.UUID_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.ENUMERATOR_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.EOBJECT_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.JSON_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.WEB_SERVICES_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.MIGRATION_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.ARRAY_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.PRIMITIVE_ARRAY_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.COMPLEX_ARRAY_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.OBJECT_ARRAY_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.UUID_ARRAY_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.BIG_DECIMAL_LITERAL);
        addEEnumLiteral(marshallerTypeEEnum, MarshallerType.INTEGER_ARRAY_LITERAL);

        initEEnum(marshallingExceptionReasonCodeEEnum, MarshallingExceptionReasonCode.class, "MarshallingExceptionReasonCode"); //$NON-NLS-1$
        addEEnumLiteral(marshallingExceptionReasonCodeEEnum, MarshallingExceptionReasonCode.CANNOT_MARSHAL_LITERAL);
        addEEnumLiteral(marshallingExceptionReasonCodeEEnum, MarshallingExceptionReasonCode.NULL_SUPPORTED_TYPE_LITERAL);
        addEEnumLiteral(marshallingExceptionReasonCodeEEnum, MarshallingExceptionReasonCode.CANNOT_DEMARSHAL_LITERAL);

        // Initialize data types
        initEDataType(classEDataType, Class.class, "Class", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$

        // Create resource
        createResource(eNS_URI);
    }

} //MarshalPackageImpl
