/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import java.io.OutputStream;
import java.nio.charset.Charset;
import java.util.Map;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import com.ibm.team.repository.common.internal.marshal.MarshalPackage;
import com.ibm.team.repository.common.internal.marshal.Marshaller;
import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.internal.marshal.MarshallingException;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Marshaller</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.team.repository.common.internal.marshal.impl.MarshallerImpl#getMarshallerType <em>Marshaller Type</em>}</li>
 *   <li>{@link com.ibm.team.repository.common.internal.marshal.impl.MarshallerImpl#getSupportedType <em>Supported Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class MarshallerImpl extends EObjectImpl implements Marshaller {
    /**
     * The default value of the '{@link #getMarshallerType() <em>Marshaller Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getMarshallerType()
     * @generated
     * @ordered
     */
    protected static final MarshallerType MARSHALLER_TYPE_EDEFAULT = MarshallerType.PRIMITIVE_LITERAL;

    /**
     * The cached value of the '{@link #getMarshallerType() <em>Marshaller Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getMarshallerType()
     * @generated
     * @ordered
     */
    protected MarshallerType marshallerType = MARSHALLER_TYPE_EDEFAULT;

    /**
     * The default value of the '{@link #getSupportedType() <em>Supported Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSupportedType()
     * @generated
     * @ordered
     */
    protected static final Class SUPPORTED_TYPE_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getSupportedType() <em>Supported Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSupportedType()
     * @generated
     * @ordered
     */
    protected Class supportedType = SUPPORTED_TYPE_EDEFAULT;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected MarshallerImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return MarshalPackage.Literals.MARSHALLER;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Class getSupportedType() {
        return supportedType;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setSupportedType(Class newSupportedType) {
        Class oldSupportedType = supportedType;
        supportedType = newSupportedType;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, MarshalPackage.MARSHALLER__SUPPORTED_TYPE, oldSupportedType, supportedType));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public MarshallerType getMarshallerType() {
        return marshallerType;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setMarshallerType(MarshallerType newMarshallerType) {
        MarshallerType oldMarshallerType = marshallerType;
        marshallerType = newMarshallerType == null ? MARSHALLER_TYPE_EDEFAULT : newMarshallerType;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, MarshalPackage.MARSHALLER__MARSHALLER_TYPE, oldMarshallerType, marshallerType));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public DataArgType getSupportedDataArgType() {
        // TODO: implement this method
        // Ensure that you remove @generated or mark it @generated NOT
        throw new UnsupportedOperationException();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String getRegistrationName() {
        // TODO: implement this method
        // Ensure that you remove @generated or mark it @generated NOT
        throw new UnsupportedOperationException();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public boolean canMarshal(Class type) {
        return canMarshal(type.getName());
    }

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void marshalObjectToOutputStream(Object object, OutputStream outputStream, Charset charset,
			Map<String, String> componentConfiguration) throws MarshallingException {
		marshalObjectToOutputStream(object, outputStream, charset);
	}

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public DataArg marshalObjectToDataArg(Object object) {
        // TODO: implement this method
        // Ensure that you remove @generated or mark it @generated NOT
        throw new UnsupportedOperationException();
    }
    
    public Object marshalAttributeValue(Object object) throws MarshallingException {
        throw new UnsupportedOperationException();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case MarshalPackage.MARSHALLER__MARSHALLER_TYPE:
                return getMarshallerType();
            case MarshalPackage.MARSHALLER__SUPPORTED_TYPE:
                return getSupportedType();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case MarshalPackage.MARSHALLER__MARSHALLER_TYPE:
                setMarshallerType((MarshallerType)newValue);
                return;
            case MarshalPackage.MARSHALLER__SUPPORTED_TYPE:
                setSupportedType((Class)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case MarshalPackage.MARSHALLER__MARSHALLER_TYPE:
                setMarshallerType(MARSHALLER_TYPE_EDEFAULT);
                return;
            case MarshalPackage.MARSHALLER__SUPPORTED_TYPE:
                setSupportedType(SUPPORTED_TYPE_EDEFAULT);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case MarshalPackage.MARSHALLER__MARSHALLER_TYPE:
                return marshallerType != MARSHALLER_TYPE_EDEFAULT;
            case MarshalPackage.MARSHALLER__SUPPORTED_TYPE:
                return SUPPORTED_TYPE_EDEFAULT == null ? supportedType != null : !SUPPORTED_TYPE_EDEFAULT.equals(supportedType);
        }
        return super.eIsSet(featureID);
    }

    public boolean canMarshal(Object object) {
        return false;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (marshallerType: "); //$NON-NLS-1$
        result.append(marshallerType);
        result.append(", supportedType: "); //$NON-NLS-1$
        result.append(supportedType);
        result.append(')');
        return result.toString();
    }

} //MarshallerImpl
