/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import java.io.InputStream;
import java.io.OutputStream;
import java.nio.charset.Charset;
import java.util.List;

import org.eclipse.emf.ecore.EClass;

import com.ibm.team.repository.common.internal.marshal.MarshalPackage;
import com.ibm.team.repository.common.internal.marshal.MarshallingException;
import com.ibm.team.repository.common.internal.marshal.PrimitiveTypeMarshaller;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.NullDataArg;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;
import com.ibm.team.repository.common.transport.internal.services.ServicesFactory;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Primitive Type Marshaller</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public abstract class PrimitiveTypeMarshallerImpl extends MarshallerImpl implements PrimitiveTypeMarshaller {
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PrimitiveTypeMarshallerImpl() {
        super();
    }

    /**
     * Get the registration name
     */
    public String getRegistrationName() {
        return getSupportedType().getName();
    }
    
    /**
     * Marshal an object to a data arg
     */
    public DataArg marshalObjectToDataArg(Object object) {
        if(object == null) {
            return createNullDataArg();
        }
        PrimitiveDataArg primitiveDataArg = ServicesFactory.eINSTANCE.createPrimitiveDataArg();
        primitiveDataArg.setType(getSupportedDataArgType());
        primitiveDataArg.setValue(object.toString());
        return primitiveDataArg;
    }
    
    private DataArg createNullDataArg() {
        NullDataArg nullDataArg = ServicesFactory.eINSTANCE.createNullDataArg();
        nullDataArg.setType(DataArgType.NULL_LITERAL);
        return nullDataArg;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg) {
        if(dataArg.getType().equals(DataArgType.NULL_LITERAL)) {
            return null;
        }
        return Float.valueOf(((PrimitiveDataArg)dataArg).getValue());
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.marshal.Marshaller#marshalObjectToOutputStream(java.lang.Object, java.io.OutputStream)
     */
    public void marshalObjectToOutputStream(Object object, OutputStream outputStream) throws MarshallingException {
        throw new UnsupportedOperationException();
    }
    
    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.internal.marshal.Marshaller#marshalObjectToOutputStream(java.lang.Object, java.io.OutputStream, java.nio.charset.Charset)
     */
    public void marshalObjectToOutputStream(Object object, OutputStream outputStream,
            Charset charset) throws MarshallingException
    {
        throw new UnsupportedOperationException();
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.marshal.Marshaller#demarshalInputStreamToObjectArray(java.io.InputStream)
     */
    public Object demarshalInputStreamToObject(InputStream inputStream) throws MarshallingException {
        throw new UnsupportedOperationException();
    }
    
    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.internal.marshal.Marshaller#demarshalInputStreamToObject(java.io.InputStream, java.nio.charset.Charset)
     */
    public Object demarshalInputStreamToObject(InputStream inputStream, Charset charset) throws MarshallingException {
        throw new UnsupportedOperationException();
    }
    
    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.marshal.Marshaller#marshalObjectToString(java.lang.Object)
     */
    public String marshalObjectToString(Object object) throws MarshallingException {
        return object.toString();
    }
    
    @Override
    public Object marshalAttributeValue(Object object) throws MarshallingException {
        return marshalObjectToString(object);
    }
    
    /**
	 * @param containedReferences  
	 */
    public Object demarshalDataArgToObject(DataArg dataArg, Class type, List containedReferences) {
        return demarshalDataArgToObject(dataArg, type);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EClass eStaticClass() {
        return MarshalPackage.Literals.PRIMITIVE_TYPE_MARSHALLER;
    }

} //PrimitiveTypeMarshallerImpl
