/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.impl;

import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;

public class ShortMarshaller extends PrimitiveTypeMarshallerImpl {

    public ShortMarshaller() {
        super();
        setMarshallerType(MarshallerType.SHORT_LITERAL);
        setSupportedType(Short.TYPE);
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.SHORT_LITERAL;
    }
    
    public DataArgType getDataArgType() {
        return DataArgType.SHORT_LITERAL;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        String stringValue = ((PrimitiveDataArg)dataArg).getValue();
        if(stringValue == null) {
            return null;
        }
        return Short.valueOf(stringValue);
    }

    public Object demarshalObjectFromString(String value) {
        return Short.valueOf(value);
    }
}
