/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
/**
 * 
 */
package com.ibm.team.repository.common.internal.marshal.impl;

import com.ibm.team.repository.common.internal.marshal.MarshallerType;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;

/**
 * Marshaller to serialize / deserialize a String object
 */
public class StringMarshaller extends PrimitiveTypeMarshallerImpl {

    public StringMarshaller() {
        super();
        setSupportedType(String.class);
        setMarshallerType(MarshallerType.STRING_LITERAL);
    }
    
    public DataArgType getSupportedDataArgType() {
        return DataArgType.STRING_LITERAL;
    }
    
    public Object demarshalDataArgToObject(DataArg dataArg, Class classZ) {
        return ((PrimitiveDataArg)dataArg).getValue();
    }
    
    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.marshal.PrimitiveTypeMarshaller#demarshalObjectObjectFromString(java.lang.String)
     */
    public Object demarshalObjectFromString(String value) {
        return value;
    }

}