/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.internal.marshal.util;

import java.io.IOException;
import java.io.OutputStream;

public class EObjectCountingOutputStream extends OutputStream {

    boolean isOpen = true;
    long size = 0;
    
    public long size(){
        return size;
    }
    
    public void write(int b) throws IOException {
        if(isOpen)
            size++;
        else
            throw new IOException();
    }
    
    public void write(byte b[], int off, int len) throws IOException {
        if(isOpen)
            size+=len;
        else
            throw new IOException();
    }
    
    public void write(byte[] b) throws IOException {
        if(isOpen)
            size += b.length;
        else
            throw new IOException();
    }

    public void close(){
        isOpen = false;
    }
    
    public void flush(){
        //Do nothing
    }
    
}
