/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.util;

import org.eclipse.emf.ecore.EObject;

import com.ibm.team.repository.common.internal.marshal.MarshallingException;
import com.ibm.team.repository.common.internal.marshal.impl.EObjectMarshaller;

public class EObjectSizeUtil {

	/**
	 * This method marshalls the eObject parameter in memory to determine
	 * its size when marshalled.  The size of the object is returned.  If any
	 * exceptions are encountered when marshalling the object, a size of -1 
	 * is returned.
	 * 
	 * @param eobject
	 * @return long
	 */
	@SuppressWarnings("deprecation")
	public static long marshalledSize(EObject eobject){
        EObjectCountingOutputStream stream = new EObjectCountingOutputStream();
        EObjectMarshaller marshaller = new EObjectMarshaller();
        try {
            marshaller.marshalObjectToOutputStream(eobject, stream);
        } catch (MarshallingException e) {
            return 1;
        }
        return stream.size();
    }
	
}
