/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.internal.marshal.util;

/**
 * A helper for json objects to convert object values to primitives.
 */
public class NumberHelper {

	/**
	 * 
	 */
	public NumberHelper() {
		// TODO Auto-generated constructor stub
	}

	private static IllegalArgumentException createIllegalArgumentException(Class claz) {
		return new IllegalArgumentException("The value cannot be converted to an " + claz.getName()); //$NON-NLS-1$
	}

	public static int getInteger(Object value) throws IllegalArgumentException {
		int rValue;
		if (value instanceof Number)
			rValue = ((Number) value).intValue();
		else if (value instanceof String)
			rValue = Integer.parseInt((String) value);
		else
			throw createIllegalArgumentException(int.class);
		return rValue;
	}

	public static long getLong(Object value) throws IllegalArgumentException {
		long rValue;
		if (value instanceof Number)
			rValue = ((Number) value).longValue();
		else if (value instanceof String)
			rValue = Long.parseLong((String) value);
		else
			throw createIllegalArgumentException(long.class);
		return rValue;
	}

	public static short getShort(Object value) throws IllegalArgumentException {
		short rValue;
		if (value instanceof Number)
			rValue = ((Number) value).shortValue();
		else if (value instanceof String)
			rValue = Short.parseShort((String) value);
		else
			throw createIllegalArgumentException(short.class);
		return rValue;
	}

	public static float getFloat(Object value) throws IllegalArgumentException {
		float rValue;
		if (value instanceof Number)
			rValue = ((Number) value).floatValue();
		else if (value instanceof String)
			rValue = Float.parseFloat((String) value);
		else
			throw createIllegalArgumentException(float.class);
		return rValue;
	}

	public static double getDouble(Object value) throws IllegalArgumentException {
		double rValue;
		if (value instanceof Number)
			rValue = ((Number) value).doubleValue();
		else if (value instanceof String)
			rValue = Double.parseDouble((String) value);
		else
			throw createIllegalArgumentException(float.class);
		return rValue;
	}

	public static byte getByte(Object value) throws IllegalArgumentException {
		byte rValue;
		if (value instanceof Number)
			rValue = ((Number) value).byteValue();
		else if (value instanceof String)
			rValue = Byte.parseByte((String) value);
		else
			throw createIllegalArgumentException(float.class);
		return rValue;
	}
}
