/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.json;

import java.io.IOException;
import java.io.Writer;

/**
 * Provide shared methods for serializing JSON objects.
 */
public interface IJSONSerializable {
	/**
     * Serialize the receiver onto the given writer.
     */
    public void serialize(Writer writer) throws IOException;
    
	/**
     * Serialize the receiver onto the given writer.
     */
    public void serialize(Writer writer, boolean verbose) throws IOException;
    
    public String toString(boolean verbose);
}
