/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.json.internal;

import java.io.IOException;
import java.io.Writer;
import java.util.Collections;
import java.util.List;
import java.util.Map;

public class SerializerVerbose extends Serializer {

    private int indent = 0;

    public SerializerVerbose(Writer writer) {
        super(writer);
    }

    @Override
    public void space() throws IOException {
        writeRawString(" "); //$NON-NLS-1$
    }

    @Override
    public void newLine() throws IOException {
        writeRawString("\n"); //$NON-NLS-1$
    }

    @Override
    public void indent() throws IOException {
        for (int i = 0; i < indent; i++)
            writeRawString("    "); //$NON-NLS-1$
    }

    @Override
    public void indentPush() {
        indent++;
    }

    @Override
    public void indentPop() {
        indent--;
        if (indent < 0)
            throw new IllegalStateException();
    }

    @Override
    public List getPropertyNames(Map map) {
        List propertyNames = super.getPropertyNames(map);

        Collections.sort(propertyNames);

        return propertyNames;
    }
}