/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.serialize;

import java.io.Reader;

/**
 * Describes operations available to deserializers.
 * 
 * Deserializers are thread-safe.  You can reuse a Deserializer 
 * across multiple threads simultaneously.
 */
public interface IDeserializer {

	/**
	 *
	 */
	public IDeserializeResult deserialize(Reader reader) throws SerializeException;
    
    /**
     * 
     */
    public Object deserializeString(String string, Class expectedType) throws SerializeException;
    
    /**
     * 
     */
    public String getFormat();
}
