/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.serialize;

/**
 * Describes a serializer for objects which can be serialized to a simple string value.
 */
public interface IPrimitiveHandler {
	
	/**
	 * Convert an object into it's string form. 
	 */
	public String objectToString(Object object) throws SerializeException;

	/**
	 * Convert a string into it's object form.
	 */
	public Object stringToObject(String string) throws SerializeException;

	/**
	 * Return the xsi type of the object, as a String[2] of namespace uri and local name. 
	 */
	public String[] getXsiType();

	/**
	 * Return whether the empty string is a valid value. 
	 */
	public boolean isEmptyValid();

}
