/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.serialize;


/**
 * Specialized IOException for serialization-specific exceptions.
 */
@SuppressWarnings("serial")
public class SerializeException extends Exception {

	/**
	 * 
	 */
	static public SerializeException from(Throwable t) {
		return new SerializeException(t.getClass().getName() + ": " + t.getMessage(), t); //$NON-NLS-1$
	}
	
	/**
	 *
	 */
	public SerializeException() {
		super();
	}

	/**
	 *
	 */
	public SerializeException(String s) {
		super(s);
	}
	
	public SerializeException(String s, Throwable cause) {
		super(s, cause);
	}
}
