/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.serialize.internal;

import java.io.IOException;
import java.io.Writer;
import java.util.List;

import org.eclipse.emf.ecore.EObject;

import com.ibm.team.repository.common.IItem;
import com.ibm.team.repository.common.IVirtual;
import com.ibm.team.repository.common.TeamRepositoryException;
import com.ibm.team.repository.common.serialize.IURISerializer;
import com.ibm.team.repository.common.transport.HttpUtil.MediaType;

/**
 * A serializer for the Atom publishing protocol.
 */
public class APPSerializer extends AbstractSerializer {

    /**
     * Constructs a new serializer instance.
     * 
     * @param type The media type for this serializer. Must not be <code>null</code>.
     * 
     * @param format Whether or not the serialized representation should be
     * formatted for human readability.  <code>true</code> to format, <code>false</code>
     * to leave representation unformatted.
     * 
     * @param The serializer used to convert between objects and URIs. Must not
     * be <code>null</code>.
     */
    public APPSerializer(MediaType type, boolean format, IURISerializer uriSerializer) {
        super(type, format, uriSerializer);
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.serialize.ISerializer2#serialize(com.ibm.team.repository.common.IItem, java.io.Writer)
     */
    public void serialize(IItem item, Writer writer) throws TeamRepositoryException {
        throw new UnsupportedOperationException("not yet implemented"); //$NON-NLS-1$
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.serialize.ISerializer2#serialize(java.util.Collection, java.io.Writer)
     */
    public void serialize(List<IItem> item, Writer writer) throws TeamRepositoryException, IOException {
        throw new UnsupportedOperationException("not yet implemented"); //$NON-NLS-1$
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.serialize.ISerializer2#serialize(org.eclipse.emf.ecore.EObject, java.io.Writer)
     */
    public void serialize(EObject object, Writer writer) throws TeamRepositoryException, IOException {
        throw new UnsupportedOperationException("not yet implemented"); //$NON-NLS-1$
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.serialize.ISerializer2#serialize(com.ibm.team.repository.common.IVirtual, java.io.Writer)
     */
    public void serialize(IVirtual item, Writer writer) throws TeamRepositoryException, IOException {
        throw new UnsupportedOperationException("not yet implemented"); //$NON-NLS-1$
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.serialize.ISerializer2#serializeVirtuals(java.util.List, java.io.Writer)
     */
    public void serializeVirtuals(List<IVirtual> items, Writer writer) throws TeamRepositoryException, IOException {
        throw new UnsupportedOperationException("not yet implemented"); //$NON-NLS-1$
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.serialize.ISerializer2#serializeList(java.util.List, java.io.Writer)
     */
    public void serializeList(List items, Writer writer) throws TeamRepositoryException, IOException {
        throw new UnsupportedOperationException("not yet implemented"); //$NON-NLS-1$
    }

    /* (non-Javadoc)
     * @see com.ibm.team.repository.common.serialize.ISerializer2#serializeException(java.lang.Throwable, java.lang.Integer, java.io.Writer)
     */
    public void serializeException(Throwable exception, Integer errorCode, Writer writer) throws TeamRepositoryException, IOException {
		// NOTE:  If this method is ever implemented, it must honor the result
		// of calling shouldAvoidSerializingExceptions() from the parent class.
        throw new UnsupportedOperationException("not yet implemented"); //$NON-NLS-1$
    }
}
