/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.serialize.internal;

import com.ibm.team.repository.common.json.JSONObject;

/**
 * Allows callers to participate in deserialization.
 */
public interface IJSONDeserializationParticipant {

	/**
	 * Called when the given throwable has been deserialized, and is about 
	 * to be passed back. 
	 * 
	 * @param jsonDeserializer The deserializer that's doing the work.  
	 * @param json The parsed representation of the JSON. 
	 * @param t The inflated exception.
	 * 
	 * @return An exception to return to the caller. 
	 */
	public Throwable deserializeErrorObj(JSONDeserializer jsonDeserializer, JSONObject json, Throwable t);
	
}
