/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.serialize.internal;

import java.io.FilterWriter;
import java.io.IOException;
import java.io.Writer;

/**
 *
 */
public class SerializingWriter extends FilterWriter {
	
	protected int indent;

	/**
	 * 
	 */
	public SerializingWriter(Writer writer) {
		super(writer);
		
		indent = 0;
	}
	
	/**
	 * 
	 */
	public boolean isVerbose() {
		return false;
	}

	/**
	 * 
	 */
	@Override
    public void write(char[] cbuf, int off, int len) throws IOException {
		super.write(cbuf, off, len);
	}

	/**
	 * 
	 */
	@Override
    public void write(int c) throws IOException {
		super.write(c);
	}

	/**
	 * 
	 */
	@Override
    public void write(String str, int off, int len) throws IOException {
		super.write(str, off, len);
	}

	/**
	 * 
	 */
	@Override
    public void write(String str) throws IOException {
		super.write(str);
	}

	/**
	 * @throws IOException 
	 */
	public void nl() throws IOException {
	}

	/**
	 * @throws IOException 
	 */
 	public void space() throws IOException {
 	 }
 
	/**
	 * @throws IOException 
	 */
	public void indent() throws IOException {
	}

	/**
	 * @throws IOException 
	 */
	public void indentPush() throws IOException {
		indent++;
	}

	/**
	 * @throws IOException 
	 */
	public void indentPop() throws IOException {
		indent--;
		if (indent < 0) throw new IllegalStateException("popped too many indents"); //$NON-NLS-1$
	}
}
