/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.serialize.internal;

import java.io.IOException;
import java.io.Writer;

/**
 *
 */
public class SerializingWriterVerbose extends SerializingWriter {

	/**
	 * 
	 */
	public SerializingWriterVerbose(Writer writer) {
		super(writer);
	}

	/**
	 * 
	 */
	@Override
    public boolean isVerbose() {
		return true;
	}

	/**
	 * 
	 */
	@Override
    public void indent() throws IOException {
		for (int i=0; i<indent; i++) {
			write("   "); //$NON-NLS-1$
		}
	}

	/**
	 * 
	 */
	@Override
    public void nl() throws IOException {
		write(String.valueOf('\n'));
	}

	/**
	 * 
	 */
	@Override
    public void space() throws IOException {
		write(String.valueOf(' '));
	}
	
	
}
