/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.common.serialize.internal;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;

import com.ibm.team.repository.common.serialize.SerializeException;


/**
 * Utility methods
 */
public class Util {

	/**
	 *  
	 */
	private Util() {
		super();
	}
	
	/**
	 * @param declaredClass 
	 * @throws SerializeException 
	 */
	static public List getStructuralFeatures(EClass eClass, Class declaredClass) throws SerializeException {

		List sfs = eClass.getEAllStructuralFeatures();
		sfs = new ArrayList(sfs);
		
		for (Iterator iter=sfs.iterator(); iter.hasNext();) {
			EStructuralFeature sf = (EStructuralFeature) iter.next();
			if (sf.isTransient()) iter.remove();
		}
		
		return sfs;
	}
	
}
