/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * @model
 */
public class DataArgType extends AbstractEnumerator {

    public DataArgType(int value, String name) {
        super(value, name);
    }
    
    /**
     * @model
     */
    public static final int VOID = 0;
    
    /**
     * @model
     */
    public static final int CHARACTER = 1;
    
    /**
     * @model
     */
    public static final int BYTE = 2;
    
    /**
     * @model
     */
    public static final int INTEGER = 3;
    
    /**
     * @model
     */
    public static final int SHORT = 4;
    
    /**
     * @model
     */
    public static final int LONG = 5;
    
    /**
     * @model
     */
    public static final int FLOAT = 6;
    
    /**
     * @model
     */
    public static final int DOUBLE = 7;
    
    /**
     * @model
     */
    public static final int STRING = 8;
    
    /**
     * @model
     */
    public static final int BOOLEAN = 9;
    
    /**
     * @model
     */
    public static final int DATE = 10;
    
    /**
     * @model
     */
    public static final int TIMESTAMP = 11;
    
    /**
     * @model
     */
    public static final int UUID = 12;
    
    /**
     * @model
     */
    public static final int COMPLEX = 13;
    
    /**
     * @model
     */
    public static final int ENUMERATOR = 14;
    
    /**
     * @model
     */
    public static final int NULL = 15;
    
    /**
     * @model
     */
    public static final int PRIMITIVE_ARRAY = 16;
    
    /**
     * @model
     */
    public static final int EOBJECT_ARRAY = 17;
    
    /**
     * @model
     */
    public static final int OBJECT_ARRAY = 18;
    
    /**
     * @model
     */
    public static final int BIG_DECIMAL = 19;     
    
    /**
     * The '<em><b>UUID ARRAY</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>UUID ARRAY</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #UUID_ARRAY_LITERAL
     * @model
     * @generated
     * @ordered
     */
    public static final int UUID_ARRAY = 20;

    /**
     * The '<em><b>INTEGER ARRAY</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>INTEGER ARRAY</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #INTEGER_ARRAY_LITERAL
     * @model
     * @generated
     * @ordered
     */
    public static final int INTEGER_ARRAY = 21;

    /**
     * The '<em><b>VOID</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #VOID
     * @generated
     * @ordered
     */
    public static final DataArgType VOID_LITERAL = new DataArgType(VOID, "VOID", "VOID"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>CHARACTER</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #CHARACTER
     * @generated
     * @ordered
     */
    public static final DataArgType CHARACTER_LITERAL = new DataArgType(CHARACTER, "CHARACTER", "CHARACTER"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>BYTE</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BYTE
     * @generated
     * @ordered
     */
    public static final DataArgType BYTE_LITERAL = new DataArgType(BYTE, "BYTE", "BYTE"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>INTEGER</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #INTEGER
     * @generated
     * @ordered
     */
    public static final DataArgType INTEGER_LITERAL = new DataArgType(INTEGER, "INTEGER", "INTEGER"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>SHORT</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #SHORT
     * @generated
     * @ordered
     */
    public static final DataArgType SHORT_LITERAL = new DataArgType(SHORT, "SHORT", "SHORT"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>LONG</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #LONG
     * @generated
     * @ordered
     */
    public static final DataArgType LONG_LITERAL = new DataArgType(LONG, "LONG", "LONG"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>FLOAT</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #FLOAT
     * @generated
     * @ordered
     */
    public static final DataArgType FLOAT_LITERAL = new DataArgType(FLOAT, "FLOAT", "FLOAT"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>DOUBLE</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #DOUBLE
     * @generated
     * @ordered
     */
    public static final DataArgType DOUBLE_LITERAL = new DataArgType(DOUBLE, "DOUBLE", "DOUBLE"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>STRING</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #STRING
     * @generated
     * @ordered
     */
    public static final DataArgType STRING_LITERAL = new DataArgType(STRING, "STRING", "STRING"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>BOOLEAN</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BOOLEAN
     * @generated
     * @ordered
     */
    public static final DataArgType BOOLEAN_LITERAL = new DataArgType(BOOLEAN, "BOOLEAN", "BOOLEAN"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>DATE</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #DATE
     * @generated
     * @ordered
     */
    public static final DataArgType DATE_LITERAL = new DataArgType(DATE, "DATE", "DATE"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>TIMESTAMP</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #TIMESTAMP
     * @generated
     * @ordered
     */
    public static final DataArgType TIMESTAMP_LITERAL = new DataArgType(TIMESTAMP, "TIMESTAMP", "TIMESTAMP"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>UUID</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #UUID
     * @generated
     * @ordered
     */
    public static final DataArgType UUID_LITERAL = new DataArgType(UUID, "UUID", "UUID"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>COMPLEX</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #COMPLEX
     * @generated
     * @ordered
     */
    public static final DataArgType COMPLEX_LITERAL = new DataArgType(COMPLEX, "COMPLEX", "COMPLEX"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>ENUMERATOR</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #ENUMERATOR
     * @generated
     * @ordered
     */
    public static final DataArgType ENUMERATOR_LITERAL = new DataArgType(ENUMERATOR, "ENUMERATOR", "ENUMERATOR"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>NULL</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #NULL
     * @generated
     * @ordered
     */
    public static final DataArgType NULL_LITERAL = new DataArgType(NULL, "NULL", "NULL"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>PRIMITIVE ARRAY</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #PRIMITIVE_ARRAY
     * @generated
     * @ordered
     */
    public static final DataArgType PRIMITIVE_ARRAY_LITERAL = new DataArgType(PRIMITIVE_ARRAY, "PRIMITIVE_ARRAY", "PRIMITIVE_ARRAY"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>EOBJECT ARRAY</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #EOBJECT_ARRAY
     * @generated
     * @ordered
     */
    public static final DataArgType EOBJECT_ARRAY_LITERAL = new DataArgType(EOBJECT_ARRAY, "EOBJECT_ARRAY", "EOBJECT_ARRAY"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>OBJECT ARRAY</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #OBJECT_ARRAY
     * @generated
     * @ordered
     */
    public static final DataArgType OBJECT_ARRAY_LITERAL = new DataArgType(OBJECT_ARRAY, "OBJECT_ARRAY", "OBJECT_ARRAY"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>BIG DECIMAL</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #BIG_DECIMAL
     * @generated
     * @ordered
     */
    public static final DataArgType BIG_DECIMAL_LITERAL = new DataArgType(BIG_DECIMAL, "BIG_DECIMAL", "BIG_DECIMAL"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>UUID ARRAY</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #UUID_ARRAY
     * @generated
     * @ordered
     */
    public static final DataArgType UUID_ARRAY_LITERAL = new DataArgType(UUID_ARRAY, "UUID_ARRAY", "UUID_ARRAY"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * The '<em><b>INTEGER ARRAY</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #INTEGER_ARRAY
     * @generated
     * @ordered
     */
    public static final DataArgType INTEGER_ARRAY_LITERAL = new DataArgType(INTEGER_ARRAY, "INTEGER_ARRAY", "INTEGER_ARRAY"); //$NON-NLS-1$ //$NON-NLS-2$

    /**
     * An array of all the '<em><b>Data Arg Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static final DataArgType[] VALUES_ARRAY =
        new DataArgType[] {
            VOID_LITERAL,
            CHARACTER_LITERAL,
            BYTE_LITERAL,
            INTEGER_LITERAL,
            SHORT_LITERAL,
            LONG_LITERAL,
            FLOAT_LITERAL,
            DOUBLE_LITERAL,
            STRING_LITERAL,
            BOOLEAN_LITERAL,
            DATE_LITERAL,
            TIMESTAMP_LITERAL,
            UUID_LITERAL,
            COMPLEX_LITERAL,
            ENUMERATOR_LITERAL,
            NULL_LITERAL,
            PRIMITIVE_ARRAY_LITERAL,
            EOBJECT_ARRAY_LITERAL,
            OBJECT_ARRAY_LITERAL,
            BIG_DECIMAL_LITERAL,
            UUID_ARRAY_LITERAL,
            INTEGER_ARRAY_LITERAL,
        };

    /**
     * A public read-only list of all the '<em><b>Data Arg Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

    /**
     * Returns the '<em><b>Data Arg Type</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static DataArgType get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            DataArgType result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Data Arg Type</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static DataArgType getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            DataArgType result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

    /**
     * Returns the '<em><b>Data Arg Type</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static DataArgType get(int value) {
        switch (value) {
            case VOID: return VOID_LITERAL;
            case CHARACTER: return CHARACTER_LITERAL;
            case BYTE: return BYTE_LITERAL;
            case INTEGER: return INTEGER_LITERAL;
            case SHORT: return SHORT_LITERAL;
            case LONG: return LONG_LITERAL;
            case FLOAT: return FLOAT_LITERAL;
            case DOUBLE: return DOUBLE_LITERAL;
            case STRING: return STRING_LITERAL;
            case BOOLEAN: return BOOLEAN_LITERAL;
            case DATE: return DATE_LITERAL;
            case TIMESTAMP: return TIMESTAMP_LITERAL;
            case UUID: return UUID_LITERAL;
            case COMPLEX: return COMPLEX_LITERAL;
            case ENUMERATOR: return ENUMERATOR_LITERAL;
            case NULL: return NULL_LITERAL;
            case PRIMITIVE_ARRAY: return PRIMITIVE_ARRAY_LITERAL;
            case EOBJECT_ARRAY: return EOBJECT_ARRAY_LITERAL;
            case OBJECT_ARRAY: return OBJECT_ARRAY_LITERAL;
            case BIG_DECIMAL: return BIG_DECIMAL_LITERAL;
            case UUID_ARRAY: return UUID_ARRAY_LITERAL;
            case INTEGER_ARRAY: return INTEGER_ARRAY_LITERAL;
        }
        return null;
    }

    /**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private DataArgType(int value, String name, String literal) {
        super(value, name, literal);
    }

}