/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services;

import org.eclipse.emf.ecore.EObject;

/**
 * Service Request and Service Response are bundled as messages and sent over the wire. 
 * @model
 */
public interface Message extends EObject {
    
    /**
     * Name of the method 
     * @model annotation="http:///com/ibm/team/core/marshal element='true'"
     */
    String getMethod();
    
    /**
     * Sets the value of the '{@link com.ibm.team.repository.common.transport.internal.services.Message#getMethod <em>Method</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Method</em>' attribute.
     * @see #getMethod()
     * @generated
     */
    void setMethod(String value);

    /**
     * Interface Name
     * @model annotation="http:///com/ibm/team/core/marshal element='true'"
     */
    String getInterface();
    /**
     * Sets the value of the '{@link com.ibm.team.repository.common.transport.internal.services.Message#getInterface <em>Interface</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Interface</em>' attribute.
     * @see #getInterface()
     * @generated
     */
    void setInterface(String value);

}
