/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services;

import org.eclipse.emf.common.util.EList;

/**
 * @model
 */
public interface PrimitiveArrayDataArg extends DataArg{
    
    /**
     * List of String values
     * @model type="String" 
     */
    EList getValues();
    
    /**
     * Indices of the elements present in the complex data arg. {@link EList} does not support
     * duplicate objects. To store 3 strings Joe, Mary and Joe in {@link PrimitiveArrayDataArg}, 
     * the strings Joe and Mary are stored in values EList while 0, 1 and 0 are the indices of the complex array.
     * 
     * @model type="int" unique="false"
     */
    EList getIndices();
}
