/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.ibm.team.repository.common.transport.internal.services.ServicesPackage
 * @generated
 */
public interface ServicesFactory extends EFactory {
    /**
     * The singleton instance of the factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    ServicesFactory eINSTANCE = com.ibm.team.repository.common.transport.internal.services.impl.ServicesFactoryImpl.init();

    /**
     * Returns a new object of class '<em>Complex Array Data Arg</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Complex Array Data Arg</em>'.
     * @generated
     */
    ComplexArrayDataArg createComplexArrayDataArg();

    /**
     * Returns a new object of class '<em>Complex Data Arg</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Complex Data Arg</em>'.
     * @generated
     */
    ComplexDataArg createComplexDataArg();

    /**
     * Returns a new object of class '<em>Message</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Message</em>'.
     * @generated
     */
    Message createMessage();

    /**
     * Returns a new object of class '<em>Primitive Array Data Arg</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Primitive Array Data Arg</em>'.
     * @generated
     */
    PrimitiveArrayDataArg createPrimitiveArrayDataArg();

    /**
     * Returns a new object of class '<em>Primitive Data Arg</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Primitive Data Arg</em>'.
     * @generated
     */
    PrimitiveDataArg createPrimitiveDataArg();

    /**
     * Returns a new object of class '<em>Request</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Request</em>'.
     * @generated
     */
    Request createRequest();

    /**
     * Returns a new object of class '<em>Response</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Response</em>'.
     * @generated
     */
    Response createResponse();

    /**
     * Returns a new object of class '<em>Null Data Arg</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Null Data Arg</em>'.
     * @generated
     */
    NullDataArg createNullDataArg();

    /**
     * Returns a new object of class '<em>Object Array Data Arg</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return a new object of class '<em>Object Array Data Arg</em>'.
     * @generated
     */
    ObjectArrayDataArg createObjectArrayDataArg();

    /**
     * Returns the package supported by this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the package supported by this factory.
     * @generated
     */
    ServicesPackage getServicesPackage();

} //ServicesFactory
