/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.ibm.team.repository.common.transport.internal.services.ServicesFactory
 * @model kind="package"
 * @generated
 */
public interface ServicesPackage extends EPackage {
    /**
     * The package name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNAME = "services"; //$NON-NLS-1$

    /**
     * The package namespace URI.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_URI = "http:///com/ibm/team/core/services.ecore"; //$NON-NLS-1$

    /**
     * The package namespace name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_PREFIX = "com.ibm.team.repository.common.services"; //$NON-NLS-1$

    /**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    ServicesPackage eINSTANCE = com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl.init();

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.DataArgImpl <em>Data Arg</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.DataArgImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getDataArg()
     * @generated
     */
    int DATA_ARG = 2;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATA_ARG__TYPE = 0;

    /**
     * The number of structural features of the '<em>Data Arg</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int DATA_ARG_FEATURE_COUNT = 1;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ComplexArrayDataArgImpl <em>Complex Array Data Arg</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ComplexArrayDataArgImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getComplexArrayDataArg()
     * @generated
     */
    int COMPLEX_ARRAY_DATA_ARG = 0;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_ARRAY_DATA_ARG__TYPE = DATA_ARG__TYPE;

    /**
     * The feature id for the '<em><b>Values</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_ARRAY_DATA_ARG__VALUES = DATA_ARG_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Indices</b></em>' attribute list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_ARRAY_DATA_ARG__INDICES = DATA_ARG_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Complex Array Data Arg</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_ARRAY_DATA_ARG_FEATURE_COUNT = DATA_ARG_FEATURE_COUNT + 2;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ComplexDataArgImpl <em>Complex Data Arg</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ComplexDataArgImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getComplexDataArg()
     * @generated
     */
    int COMPLEX_DATA_ARG = 1;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_DATA_ARG__TYPE = DATA_ARG__TYPE;

    /**
     * The feature id for the '<em><b>Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_DATA_ARG__VALUE = DATA_ARG_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Complex Data Arg</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int COMPLEX_DATA_ARG_FEATURE_COUNT = DATA_ARG_FEATURE_COUNT + 1;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.MessageImpl <em>Message</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.MessageImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getMessage()
     * @generated
     */
    int MESSAGE = 3;

    /**
     * The feature id for the '<em><b>Method</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MESSAGE__METHOD = 0;

    /**
     * The feature id for the '<em><b>Interface</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MESSAGE__INTERFACE = 1;

    /**
     * The number of structural features of the '<em>Message</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int MESSAGE_FEATURE_COUNT = 2;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveArrayDataArgImpl <em>Primitive Array Data Arg</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveArrayDataArgImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getPrimitiveArrayDataArg()
     * @generated
     */
    int PRIMITIVE_ARRAY_DATA_ARG = 4;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_ARRAY_DATA_ARG__TYPE = DATA_ARG__TYPE;

    /**
     * The feature id for the '<em><b>Values</b></em>' attribute list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_ARRAY_DATA_ARG__VALUES = DATA_ARG_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Indices</b></em>' attribute list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_ARRAY_DATA_ARG__INDICES = DATA_ARG_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>Primitive Array Data Arg</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_ARRAY_DATA_ARG_FEATURE_COUNT = DATA_ARG_FEATURE_COUNT + 2;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveDataArgImpl <em>Primitive Data Arg</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveDataArgImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getPrimitiveDataArg()
     * @generated
     */
    int PRIMITIVE_DATA_ARG = 5;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_DATA_ARG__TYPE = DATA_ARG__TYPE;

    /**
     * The feature id for the '<em><b>Value</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_DATA_ARG__VALUE = DATA_ARG_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Primitive Data Arg</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int PRIMITIVE_DATA_ARG_FEATURE_COUNT = DATA_ARG_FEATURE_COUNT + 1;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.RequestImpl <em>Request</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.RequestImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getRequest()
     * @generated
     */
    int REQUEST = 6;

    /**
     * The feature id for the '<em><b>Method</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REQUEST__METHOD = MESSAGE__METHOD;

    /**
     * The feature id for the '<em><b>Interface</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REQUEST__INTERFACE = MESSAGE__INTERFACE;

    /**
     * The feature id for the '<em><b>Parameters</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REQUEST__PARAMETERS = MESSAGE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Request</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int REQUEST_FEATURE_COUNT = MESSAGE_FEATURE_COUNT + 1;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ResponseImpl <em>Response</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ResponseImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getResponse()
     * @generated
     */
    int RESPONSE = 7;

    /**
     * The feature id for the '<em><b>Method</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESPONSE__METHOD = MESSAGE__METHOD;

    /**
     * The feature id for the '<em><b>Interface</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESPONSE__INTERFACE = MESSAGE__INTERFACE;

    /**
     * The feature id for the '<em><b>Return Value</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESPONSE__RETURN_VALUE = MESSAGE_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Response</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int RESPONSE_FEATURE_COUNT = MESSAGE_FEATURE_COUNT + 1;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.EStringToEObjectMapEntryImpl <em>EString To EObject Map Entry</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.EStringToEObjectMapEntryImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getEStringToEObjectMapEntry()
     * @generated
     */
    int ESTRING_TO_EOBJECT_MAP_ENTRY = 8;

    /**
     * The feature id for the '<em><b>Key</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ESTRING_TO_EOBJECT_MAP_ENTRY__KEY = 0;

    /**
     * The feature id for the '<em><b>Value</b></em>' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ESTRING_TO_EOBJECT_MAP_ENTRY__VALUE = 1;

    /**
     * The number of structural features of the '<em>EString To EObject Map Entry</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ESTRING_TO_EOBJECT_MAP_ENTRY_FEATURE_COUNT = 2;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.NullDataArgImpl <em>Null Data Arg</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.NullDataArgImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getNullDataArg()
     * @generated
     */
    int NULL_DATA_ARG = 9;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NULL_DATA_ARG__TYPE = DATA_ARG__TYPE;

    /**
     * The number of structural features of the '<em>Null Data Arg</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int NULL_DATA_ARG_FEATURE_COUNT = DATA_ARG_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ObjectArrayDataArgImpl <em>Object Array Data Arg</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ObjectArrayDataArgImpl
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getObjectArrayDataArg()
     * @generated
     */
    int OBJECT_ARRAY_DATA_ARG = 10;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OBJECT_ARRAY_DATA_ARG__TYPE = DATA_ARG__TYPE;

    /**
     * The feature id for the '<em><b>Data Args</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OBJECT_ARRAY_DATA_ARG__DATA_ARGS = DATA_ARG_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Object Array Data Arg</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int OBJECT_ARRAY_DATA_ARG_FEATURE_COUNT = DATA_ARG_FEATURE_COUNT + 1;

    /**
     * The meta object id for the '{@link com.ibm.team.repository.common.transport.internal.services.DataArgType <em>Data Arg Type</em>}' enum.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.ibm.team.repository.common.transport.internal.services.DataArgType
     * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getDataArgType()
     * @generated
     */
    int DATA_ARG_TYPE = 11;


    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg <em>Complex Array Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Complex Array Data Arg</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg
     * @generated
     */
    EClass getComplexArrayDataArg();

    /**
     * Returns the meta object for the reference list '{@link com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg#getValues <em>Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Values</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg#getValues()
     * @see #getComplexArrayDataArg()
     * @generated
     */
    EReference getComplexArrayDataArg_Values();

    /**
     * Returns the meta object for the attribute list '{@link com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg#getIndices <em>Indices</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute list '<em>Indices</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg#getIndices()
     * @see #getComplexArrayDataArg()
     * @generated
     */
    EAttribute getComplexArrayDataArg_Indices();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.ComplexDataArg <em>Complex Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Complex Data Arg</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.ComplexDataArg
     * @generated
     */
    EClass getComplexDataArg();

    /**
     * Returns the meta object for the reference '{@link com.ibm.team.repository.common.transport.internal.services.ComplexDataArg#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Value</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.ComplexDataArg#getValue()
     * @see #getComplexDataArg()
     * @generated
     */
    EReference getComplexDataArg_Value();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.DataArg <em>Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Data Arg</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.DataArg
     * @generated
     */
    EClass getDataArg();

    /**
     * Returns the meta object for the attribute '{@link com.ibm.team.repository.common.transport.internal.services.DataArg#getType <em>Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Type</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.DataArg#getType()
     * @see #getDataArg()
     * @generated
     */
    EAttribute getDataArg_Type();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.Message <em>Message</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Message</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.Message
     * @generated
     */
    EClass getMessage();

    /**
     * Returns the meta object for the attribute '{@link com.ibm.team.repository.common.transport.internal.services.Message#getMethod <em>Method</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Method</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.Message#getMethod()
     * @see #getMessage()
     * @generated
     */
    EAttribute getMessage_Method();

    /**
     * Returns the meta object for the attribute '{@link com.ibm.team.repository.common.transport.internal.services.Message#getInterface <em>Interface</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Interface</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.Message#getInterface()
     * @see #getMessage()
     * @generated
     */
    EAttribute getMessage_Interface();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg <em>Primitive Array Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Primitive Array Data Arg</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg
     * @generated
     */
    EClass getPrimitiveArrayDataArg();

    /**
     * Returns the meta object for the attribute list '{@link com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg#getValues <em>Values</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute list '<em>Values</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg#getValues()
     * @see #getPrimitiveArrayDataArg()
     * @generated
     */
    EAttribute getPrimitiveArrayDataArg_Values();

    /**
     * Returns the meta object for the attribute list '{@link com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg#getIndices <em>Indices</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute list '<em>Indices</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg#getIndices()
     * @see #getPrimitiveArrayDataArg()
     * @generated
     */
    EAttribute getPrimitiveArrayDataArg_Indices();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg <em>Primitive Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Primitive Data Arg</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg
     * @generated
     */
    EClass getPrimitiveDataArg();

    /**
     * Returns the meta object for the attribute '{@link com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Value</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg#getValue()
     * @see #getPrimitiveDataArg()
     * @generated
     */
    EAttribute getPrimitiveDataArg_Value();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.Request <em>Request</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Request</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.Request
     * @generated
     */
    EClass getRequest();

    /**
     * Returns the meta object for the containment reference list '{@link com.ibm.team.repository.common.transport.internal.services.Request#getParameters <em>Parameters</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Parameters</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.Request#getParameters()
     * @see #getRequest()
     * @generated
     */
    EReference getRequest_Parameters();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.Response <em>Response</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Response</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.Response
     * @generated
     */
    EClass getResponse();

    /**
     * Returns the meta object for the containment reference '{@link com.ibm.team.repository.common.transport.internal.services.Response#getReturnValue <em>Return Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference '<em>Return Value</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.Response#getReturnValue()
     * @see #getResponse()
     * @generated
     */
    EReference getResponse_ReturnValue();

    /**
     * Returns the meta object for class '{@link java.util.Map.Entry <em>EString To EObject Map Entry</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>EString To EObject Map Entry</em>'.
     * @see java.util.Map.Entry
     * @model keyDataType="org.eclipse.emf.ecore.EString"
     *        valueType="org.eclipse.emf.ecore.EObject"
     * @generated
     */
    EClass getEStringToEObjectMapEntry();

    /**
     * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Key</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Key</em>'.
     * @see java.util.Map.Entry
     * @see #getEStringToEObjectMapEntry()
     * @generated
     */
    EAttribute getEStringToEObjectMapEntry_Key();

    /**
     * Returns the meta object for the reference '{@link java.util.Map.Entry <em>Value</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Value</em>'.
     * @see java.util.Map.Entry
     * @see #getEStringToEObjectMapEntry()
     * @generated
     */
    EReference getEStringToEObjectMapEntry_Value();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.NullDataArg <em>Null Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Null Data Arg</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.NullDataArg
     * @generated
     */
    EClass getNullDataArg();

    /**
     * Returns the meta object for class '{@link com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg <em>Object Array Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Object Array Data Arg</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg
     * @generated
     */
    EClass getObjectArrayDataArg();

    /**
     * Returns the meta object for the containment reference list '{@link com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg#getDataArgs <em>Data Args</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Data Args</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg#getDataArgs()
     * @see #getObjectArrayDataArg()
     * @generated
     */
    EReference getObjectArrayDataArg_DataArgs();

    /**
     * Returns the meta object for enum '{@link com.ibm.team.repository.common.transport.internal.services.DataArgType <em>Data Arg Type</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for enum '<em>Data Arg Type</em>'.
     * @see com.ibm.team.repository.common.transport.internal.services.DataArgType
     * @generated
     */
    EEnum getDataArgType();

    /**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
    ServicesFactory getServicesFactory();

    /**
     * <!-- begin-user-doc -->
     * Defines literals for the meta objects that represent
     * <ul>
     *   <li>each class,</li>
     *   <li>each feature of each class,</li>
     *   <li>each enum,</li>
     *   <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("hiding")
    interface Literals  {
        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ComplexArrayDataArgImpl <em>Complex Array Data Arg</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ComplexArrayDataArgImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getComplexArrayDataArg()
         * @generated
         */
		EClass COMPLEX_ARRAY_DATA_ARG = eINSTANCE.getComplexArrayDataArg();

        /**
         * The meta object literal for the '<em><b>Values</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference COMPLEX_ARRAY_DATA_ARG__VALUES = eINSTANCE.getComplexArrayDataArg_Values();

        /**
         * The meta object literal for the '<em><b>Indices</b></em>' attribute list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute COMPLEX_ARRAY_DATA_ARG__INDICES = eINSTANCE.getComplexArrayDataArg_Indices();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ComplexDataArgImpl <em>Complex Data Arg</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ComplexDataArgImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getComplexDataArg()
         * @generated
         */
        EClass COMPLEX_DATA_ARG = eINSTANCE.getComplexDataArg();

        /**
         * The meta object literal for the '<em><b>Value</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference COMPLEX_DATA_ARG__VALUE = eINSTANCE.getComplexDataArg_Value();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.DataArgImpl <em>Data Arg</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.DataArgImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getDataArg()
         * @generated
         */
        EClass DATA_ARG = eINSTANCE.getDataArg();

        /**
         * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute DATA_ARG__TYPE = eINSTANCE.getDataArg_Type();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.MessageImpl <em>Message</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.MessageImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getMessage()
         * @generated
         */
        EClass MESSAGE = eINSTANCE.getMessage();

        /**
         * The meta object literal for the '<em><b>Method</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute MESSAGE__METHOD = eINSTANCE.getMessage_Method();

        /**
         * The meta object literal for the '<em><b>Interface</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute MESSAGE__INTERFACE = eINSTANCE.getMessage_Interface();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveArrayDataArgImpl <em>Primitive Array Data Arg</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveArrayDataArgImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getPrimitiveArrayDataArg()
         * @generated
         */
        EClass PRIMITIVE_ARRAY_DATA_ARG = eINSTANCE.getPrimitiveArrayDataArg();

        /**
         * The meta object literal for the '<em><b>Values</b></em>' attribute list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute PRIMITIVE_ARRAY_DATA_ARG__VALUES = eINSTANCE.getPrimitiveArrayDataArg_Values();

        /**
         * The meta object literal for the '<em><b>Indices</b></em>' attribute list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute PRIMITIVE_ARRAY_DATA_ARG__INDICES = eINSTANCE.getPrimitiveArrayDataArg_Indices();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveDataArgImpl <em>Primitive Data Arg</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.PrimitiveDataArgImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getPrimitiveDataArg()
         * @generated
         */
        EClass PRIMITIVE_DATA_ARG = eINSTANCE.getPrimitiveDataArg();

        /**
         * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute PRIMITIVE_DATA_ARG__VALUE = eINSTANCE.getPrimitiveDataArg_Value();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.RequestImpl <em>Request</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.RequestImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getRequest()
         * @generated
         */
        EClass REQUEST = eINSTANCE.getRequest();

        /**
         * The meta object literal for the '<em><b>Parameters</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference REQUEST__PARAMETERS = eINSTANCE.getRequest_Parameters();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ResponseImpl <em>Response</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ResponseImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getResponse()
         * @generated
         */
        EClass RESPONSE = eINSTANCE.getResponse();

        /**
         * The meta object literal for the '<em><b>Return Value</b></em>' containment reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference RESPONSE__RETURN_VALUE = eINSTANCE.getResponse_ReturnValue();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.EStringToEObjectMapEntryImpl <em>EString To EObject Map Entry</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.EStringToEObjectMapEntryImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getEStringToEObjectMapEntry()
         * @generated
         */
        EClass ESTRING_TO_EOBJECT_MAP_ENTRY = eINSTANCE.getEStringToEObjectMapEntry();

        /**
         * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute ESTRING_TO_EOBJECT_MAP_ENTRY__KEY = eINSTANCE.getEStringToEObjectMapEntry_Key();

        /**
         * The meta object literal for the '<em><b>Value</b></em>' reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference ESTRING_TO_EOBJECT_MAP_ENTRY__VALUE = eINSTANCE.getEStringToEObjectMapEntry_Value();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.NullDataArgImpl <em>Null Data Arg</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.NullDataArgImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getNullDataArg()
         * @generated
         */
        EClass NULL_DATA_ARG = eINSTANCE.getNullDataArg();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.impl.ObjectArrayDataArgImpl <em>Object Array Data Arg</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ObjectArrayDataArgImpl
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getObjectArrayDataArg()
         * @generated
         */
        EClass OBJECT_ARRAY_DATA_ARG = eINSTANCE.getObjectArrayDataArg();

        /**
         * The meta object literal for the '<em><b>Data Args</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference OBJECT_ARRAY_DATA_ARG__DATA_ARGS = eINSTANCE.getObjectArrayDataArg_DataArgs();

        /**
         * The meta object literal for the '{@link com.ibm.team.repository.common.transport.internal.services.DataArgType <em>Data Arg Type</em>}' enum.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.ibm.team.repository.common.transport.internal.services.DataArgType
         * @see com.ibm.team.repository.common.transport.internal.services.impl.ServicesPackageImpl#getDataArgType()
         * @generated
         */
        EEnum DATA_ARG_TYPE = eINSTANCE.getDataArgType();

    }

} //ServicesPackage
