/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.ServicesPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Object Array Data Arg</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.ibm.team.repository.common.transport.internal.services.impl.ObjectArrayDataArgImpl#getDataArgs <em>Data Args</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ObjectArrayDataArgImpl extends DataArgImpl implements ObjectArrayDataArg {
    /**
     * The cached value of the '{@link #getDataArgs() <em>Data Args</em>}' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDataArgs()
     * @generated
     * @ordered
     */
    protected EList dataArgs;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ObjectArrayDataArgImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EClass eStaticClass() {
        return ServicesPackage.Literals.OBJECT_ARRAY_DATA_ARG;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EList getDataArgs() {
        if (dataArgs == null) {
            dataArgs = new EObjectContainmentEList(DataArg.class, this, ServicesPackage.OBJECT_ARRAY_DATA_ARG__DATA_ARGS);
        }
        return dataArgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ServicesPackage.OBJECT_ARRAY_DATA_ARG__DATA_ARGS:
                return ((InternalEList)getDataArgs()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case ServicesPackage.OBJECT_ARRAY_DATA_ARG__DATA_ARGS:
                return getDataArgs();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case ServicesPackage.OBJECT_ARRAY_DATA_ARG__DATA_ARGS:
                getDataArgs().clear();
                getDataArgs().addAll((Collection)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void eUnset(int featureID) {
        switch (featureID) {
            case ServicesPackage.OBJECT_ARRAY_DATA_ARG__DATA_ARGS:
                getDataArgs().clear();
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case ServicesPackage.OBJECT_ARRAY_DATA_ARG__DATA_ARGS:
                return dataArgs != null && !dataArgs.isEmpty();
        }
        return super.eIsSet(featureID);
    }

} //ObjectArrayDataArgImpl
