/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services.impl;

import java.util.Map;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.ComplexDataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArgType;
import com.ibm.team.repository.common.transport.internal.services.Message;
import com.ibm.team.repository.common.transport.internal.services.NullDataArg;
import com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;
import com.ibm.team.repository.common.transport.internal.services.Request;
import com.ibm.team.repository.common.transport.internal.services.Response;
import com.ibm.team.repository.common.transport.internal.services.ServicesFactory;
import com.ibm.team.repository.common.transport.internal.services.ServicesPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ServicesPackageImpl extends EPackageImpl implements ServicesPackage {
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass complexArrayDataArgEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass complexDataArgEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass dataArgEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass messageEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass primitiveArrayDataArgEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass primitiveDataArgEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass requestEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass responseEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass eStringToEObjectMapEntryEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass nullDataArgEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass objectArrayDataArgEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EEnum dataArgTypeEEnum = null;

    /**
     * Creates an instance of the model <b>Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
     * package URI value.
     * <p>Note: the correct way to create the package is via the static
     * factory method {@link #init init()}, which also performs
     * initialization of the package, or returns the registered package,
     * if one already exists.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see com.ibm.team.repository.common.transport.internal.services.ServicesPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private ServicesPackageImpl() {
        super(eNS_URI, ServicesFactory.eINSTANCE);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static boolean isInited = false;

    /**
     * Creates, registers, and initializes the <b>Package</b> for this
     * model, and for any others upon which it depends.  Simple
     * dependencies are satisfied by calling this method on all
     * dependent packages before doing anything else.  This method drives
     * initialization for interdependent packages directly, in parallel
     * with this package, itself.
     * <p>Of this package and its interdependencies, all packages which
     * have not yet been registered by their URI values are first created
     * and registered.  The packages are then initialized in two steps:
     * meta-model objects for all of the packages are created before any
     * are initialized, since one package's meta-model objects may refer to
     * those of another.
     * <p>Invocation of this method will not affect any packages that have
     * already been initialized.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
    public static ServicesPackage init() {
        if (isInited) return (ServicesPackage)EPackage.Registry.INSTANCE.getEPackage(ServicesPackage.eNS_URI);

        // Obtain or create and register package
        ServicesPackageImpl theServicesPackage = (ServicesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof ServicesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new ServicesPackageImpl());

        isInited = true;

        // Create package meta-data objects
        theServicesPackage.createPackageContents();

        // Initialize created meta-data
        theServicesPackage.initializePackageContents();

        // Mark meta-data to indicate it can't be changed
        theServicesPackage.freeze();

        return theServicesPackage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getComplexArrayDataArg() {
        return complexArrayDataArgEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getComplexArrayDataArg_Values() {
        return (EReference)complexArrayDataArgEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getComplexArrayDataArg_Indices() {
        return (EAttribute)complexArrayDataArgEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getComplexDataArg() {
        return complexDataArgEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getComplexDataArg_Value() {
        return (EReference)complexDataArgEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getDataArg() {
        return dataArgEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getDataArg_Type() {
        return (EAttribute)dataArgEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getMessage() {
        return messageEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getMessage_Method() {
        return (EAttribute)messageEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getMessage_Interface() {
        return (EAttribute)messageEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getPrimitiveArrayDataArg() {
        return primitiveArrayDataArgEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getPrimitiveArrayDataArg_Values() {
        return (EAttribute)primitiveArrayDataArgEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getPrimitiveArrayDataArg_Indices() {
        return (EAttribute)primitiveArrayDataArgEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getPrimitiveDataArg() {
        return primitiveDataArgEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getPrimitiveDataArg_Value() {
        return (EAttribute)primitiveDataArgEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getRequest() {
        return requestEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getRequest_Parameters() {
        return (EReference)requestEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getResponse() {
        return responseEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getResponse_ReturnValue() {
        return (EReference)responseEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getEStringToEObjectMapEntry() {
        return eStringToEObjectMapEntryEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getEStringToEObjectMapEntry_Key() {
        return (EAttribute)eStringToEObjectMapEntryEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getEStringToEObjectMapEntry_Value() {
        return (EReference)eStringToEObjectMapEntryEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getNullDataArg() {
        return nullDataArgEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getObjectArrayDataArg() {
        return objectArrayDataArgEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getObjectArrayDataArg_DataArgs() {
        return (EReference)objectArrayDataArgEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EEnum getDataArgType() {
        return dataArgTypeEEnum;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ServicesFactory getServicesFactory() {
        return (ServicesFactory)getEFactoryInstance();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private boolean isCreated = false;

    /**
     * Creates the meta-model objects for the package.  This method is
     * guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void createPackageContents() {
        if (isCreated) return;
        isCreated = true;

        // Create classes and their features
        complexArrayDataArgEClass = createEClass(COMPLEX_ARRAY_DATA_ARG);
        createEReference(complexArrayDataArgEClass, COMPLEX_ARRAY_DATA_ARG__VALUES);
        createEAttribute(complexArrayDataArgEClass, COMPLEX_ARRAY_DATA_ARG__INDICES);

        complexDataArgEClass = createEClass(COMPLEX_DATA_ARG);
        createEReference(complexDataArgEClass, COMPLEX_DATA_ARG__VALUE);

        dataArgEClass = createEClass(DATA_ARG);
        createEAttribute(dataArgEClass, DATA_ARG__TYPE);

        messageEClass = createEClass(MESSAGE);
        createEAttribute(messageEClass, MESSAGE__METHOD);
        createEAttribute(messageEClass, MESSAGE__INTERFACE);

        primitiveArrayDataArgEClass = createEClass(PRIMITIVE_ARRAY_DATA_ARG);
        createEAttribute(primitiveArrayDataArgEClass, PRIMITIVE_ARRAY_DATA_ARG__VALUES);
        createEAttribute(primitiveArrayDataArgEClass, PRIMITIVE_ARRAY_DATA_ARG__INDICES);

        primitiveDataArgEClass = createEClass(PRIMITIVE_DATA_ARG);
        createEAttribute(primitiveDataArgEClass, PRIMITIVE_DATA_ARG__VALUE);

        requestEClass = createEClass(REQUEST);
        createEReference(requestEClass, REQUEST__PARAMETERS);

        responseEClass = createEClass(RESPONSE);
        createEReference(responseEClass, RESPONSE__RETURN_VALUE);

        eStringToEObjectMapEntryEClass = createEClass(ESTRING_TO_EOBJECT_MAP_ENTRY);
        createEAttribute(eStringToEObjectMapEntryEClass, ESTRING_TO_EOBJECT_MAP_ENTRY__KEY);
        createEReference(eStringToEObjectMapEntryEClass, ESTRING_TO_EOBJECT_MAP_ENTRY__VALUE);

        nullDataArgEClass = createEClass(NULL_DATA_ARG);

        objectArrayDataArgEClass = createEClass(OBJECT_ARRAY_DATA_ARG);
        createEReference(objectArrayDataArgEClass, OBJECT_ARRAY_DATA_ARG__DATA_ARGS);

        // Create enums
        dataArgTypeEEnum = createEEnum(DATA_ARG_TYPE);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model.  This
     * method is guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void initializePackageContents() {
        if (isInitialized) return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Add supertypes to classes
        complexArrayDataArgEClass.getESuperTypes().add(this.getDataArg());
        complexDataArgEClass.getESuperTypes().add(this.getDataArg());
        primitiveArrayDataArgEClass.getESuperTypes().add(this.getDataArg());
        primitiveDataArgEClass.getESuperTypes().add(this.getDataArg());
        requestEClass.getESuperTypes().add(this.getMessage());
        responseEClass.getESuperTypes().add(this.getMessage());
        nullDataArgEClass.getESuperTypes().add(this.getDataArg());
        objectArrayDataArgEClass.getESuperTypes().add(this.getDataArg());

        // Initialize classes and features; add operations and parameters
        initEClass(complexArrayDataArgEClass, ComplexArrayDataArg.class, "ComplexArrayDataArg", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEReference(getComplexArrayDataArg_Values(), ecorePackage.getEObject(), null, "values", null, 0, -1, ComplexArrayDataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
        initEAttribute(getComplexArrayDataArg_Indices(), ecorePackage.getEInt(), "indices", null, 0, -1, ComplexArrayDataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(complexDataArgEClass, ComplexDataArg.class, "ComplexDataArg", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEReference(getComplexDataArg_Value(), ecorePackage.getEObject(), null, "value", null, 0, 1, ComplexDataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(dataArgEClass, DataArg.class, "DataArg", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEAttribute(getDataArg_Type(), this.getDataArgType(), "type", null, 0, 1, DataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(messageEClass, Message.class, "Message", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEAttribute(getMessage_Method(), ecorePackage.getEString(), "method", null, 0, 1, Message.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
        initEAttribute(getMessage_Interface(), ecorePackage.getEString(), "interface", null, 0, 1, Message.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(primitiveArrayDataArgEClass, PrimitiveArrayDataArg.class, "PrimitiveArrayDataArg", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEAttribute(getPrimitiveArrayDataArg_Values(), ecorePackage.getEString(), "values", null, 0, -1, PrimitiveArrayDataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
        initEAttribute(getPrimitiveArrayDataArg_Indices(), ecorePackage.getEInt(), "indices", null, 0, -1, PrimitiveArrayDataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(primitiveDataArgEClass, PrimitiveDataArg.class, "PrimitiveDataArg", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEAttribute(getPrimitiveDataArg_Value(), ecorePackage.getEString(), "value", null, 0, 1, PrimitiveDataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(requestEClass, Request.class, "Request", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEReference(getRequest_Parameters(), this.getDataArg(), null, "parameters", null, 0, -1, Request.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(responseEClass, Response.class, "Response", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEReference(getResponse_ReturnValue(), this.getDataArg(), null, "returnValue", null, 0, 1, Response.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(eStringToEObjectMapEntryEClass, Map.Entry.class, "EStringToEObjectMapEntry", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEAttribute(getEStringToEObjectMapEntry_Key(), ecorePackage.getEString(), "key", null, 0, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$
        initEReference(getEStringToEObjectMapEntry_Value(), ecorePackage.getEObject(), null, "value", null, 0, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        initEClass(nullDataArgEClass, NullDataArg.class, "NullDataArg", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$

        initEClass(objectArrayDataArgEClass, ObjectArrayDataArg.class, "ObjectArrayDataArg", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS); //$NON-NLS-1$
        initEReference(getObjectArrayDataArg_DataArgs(), this.getDataArg(), null, "dataArgs", null, 0, -1, ObjectArrayDataArg.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED); //$NON-NLS-1$

        // Initialize enums and add enum literals
        initEEnum(dataArgTypeEEnum, DataArgType.class, "DataArgType"); //$NON-NLS-1$
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.VOID_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.CHARACTER_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.BYTE_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.INTEGER_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.SHORT_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.LONG_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.FLOAT_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.DOUBLE_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.STRING_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.BOOLEAN_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.DATE_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.TIMESTAMP_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.UUID_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.COMPLEX_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.ENUMERATOR_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.NULL_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.PRIMITIVE_ARRAY_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.EOBJECT_ARRAY_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.OBJECT_ARRAY_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.BIG_DECIMAL_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.UUID_ARRAY_LITERAL);
        addEEnumLiteral(dataArgTypeEEnum, DataArgType.INTEGER_ARRAY_LITERAL);

        // Create resource
        createResource(eNS_URI);

        // Create annotations
        // http:///com/ibm/team/core/marshal
        createMarshalAnnotations();
    }

    /**
     * Initializes the annotations for <b>http:///com/ibm/team/core/marshal</b>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void createMarshalAnnotations() {
        String source = "http:///com/ibm/team/core/marshal"; //$NON-NLS-1$		
        addAnnotation
          (getComplexArrayDataArg_Values(), 
           source, 
           new String[] {
             "containment", "true" //$NON-NLS-1$ //$NON-NLS-2$
           });		
        addAnnotation
          (getComplexDataArg_Value(), 
           source, 
           new String[] {
             "containment", "true" //$NON-NLS-1$ //$NON-NLS-2$
           });		
        addAnnotation
          (getMessage_Method(), 
           source, 
           new String[] {
             "element", "true" //$NON-NLS-1$ //$NON-NLS-2$
           });		
        addAnnotation
          (getMessage_Interface(), 
           source, 
           new String[] {
             "element", "true" //$NON-NLS-1$ //$NON-NLS-2$
           });		
        addAnnotation
          (getPrimitiveDataArg_Value(), 
           source, 
           new String[] {
             "element", "true" //$NON-NLS-1$ //$NON-NLS-2$
           });
    }

} //ServicesPackageImpl
