/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services.util;

import java.util.Map;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.ComplexDataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.Message;
import com.ibm.team.repository.common.transport.internal.services.NullDataArg;
import com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;
import com.ibm.team.repository.common.transport.internal.services.Request;
import com.ibm.team.repository.common.transport.internal.services.Response;
import com.ibm.team.repository.common.transport.internal.services.ServicesPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.ibm.team.repository.common.transport.internal.services.ServicesPackage
 * @generated
 */
public class ServicesAdapterFactory extends AdapterFactoryImpl {
    /**
     * The cached model package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static ServicesPackage modelPackage;

    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ServicesAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = ServicesPackage.eINSTANCE;
        }
    }

    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc -->
     * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
     * <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

    /**
     * The switch the delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServicesSwitch modelSwitch =
        new ServicesSwitch() {
            public Object caseComplexArrayDataArg(ComplexArrayDataArg object) {
                return createComplexArrayDataArgAdapter();
            }
            public Object caseComplexDataArg(ComplexDataArg object) {
                return createComplexDataArgAdapter();
            }
            public Object caseDataArg(DataArg object) {
                return createDataArgAdapter();
            }
            public Object caseMessage(Message object) {
                return createMessageAdapter();
            }
            public Object casePrimitiveArrayDataArg(PrimitiveArrayDataArg object) {
                return createPrimitiveArrayDataArgAdapter();
            }
            public Object casePrimitiveDataArg(PrimitiveDataArg object) {
                return createPrimitiveDataArgAdapter();
            }
            public Object caseRequest(Request object) {
                return createRequestAdapter();
            }
            public Object caseResponse(Response object) {
                return createResponseAdapter();
            }
            public Object caseEStringToEObjectMapEntry(Map.Entry object) {
                return createEStringToEObjectMapEntryAdapter();
            }
            public Object caseNullDataArg(NullDataArg object) {
                return createNullDataArgAdapter();
            }
            public Object caseObjectArrayDataArg(ObjectArrayDataArg object) {
                return createObjectArrayDataArgAdapter();
            }
            public Object defaultCase(EObject object) {
                return createEObjectAdapter();
            }
        };

    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    public Adapter createAdapter(Notifier target) {
        return (Adapter)modelSwitch.doSwitch((EObject)target);
    }


    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg <em>Complex Array Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg
     * @generated
     */
    public Adapter createComplexArrayDataArgAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.ComplexDataArg <em>Complex Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.ComplexDataArg
     * @generated
     */
    public Adapter createComplexDataArgAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.DataArg <em>Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.DataArg
     * @generated
     */
    public Adapter createDataArgAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.Message <em>Message</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.Message
     * @generated
     */
    public Adapter createMessageAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg <em>Primitive Array Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg
     * @generated
     */
    public Adapter createPrimitiveArrayDataArgAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg <em>Primitive Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg
     * @generated
     */
    public Adapter createPrimitiveDataArgAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.Request <em>Request</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.Request
     * @generated
     */
    public Adapter createRequestAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.Response <em>Response</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.Response
     * @generated
     */
    public Adapter createResponseAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link java.util.Map.Entry <em>EString To EObject Map Entry</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see java.util.Map.Entry
     * @generated
     */
    public Adapter createEStringToEObjectMapEntryAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.NullDataArg <em>Null Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.NullDataArg
     * @generated
     */
    public Adapter createNullDataArgAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg <em>Object Array Data Arg</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg
     * @generated
     */
    public Adapter createObjectArrayDataArgAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc -->
     * This default implementation returns null.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter() {
        return null;
    }

} //ServicesAdapterFactory
