/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.common.transport.internal.services.util;

import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import com.ibm.team.repository.common.transport.internal.services.ComplexArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.ComplexDataArg;
import com.ibm.team.repository.common.transport.internal.services.DataArg;
import com.ibm.team.repository.common.transport.internal.services.Message;
import com.ibm.team.repository.common.transport.internal.services.NullDataArg;
import com.ibm.team.repository.common.transport.internal.services.ObjectArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveArrayDataArg;
import com.ibm.team.repository.common.transport.internal.services.PrimitiveDataArg;
import com.ibm.team.repository.common.transport.internal.services.Request;
import com.ibm.team.repository.common.transport.internal.services.Response;
import com.ibm.team.repository.common.transport.internal.services.ServicesPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.ibm.team.repository.common.transport.internal.services.ServicesPackage
 * @generated
 */
public class ServicesSwitch {
    /**
     * The cached model package
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected static ServicesPackage modelPackage;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ServicesSwitch() {
        if (modelPackage == null) {
            modelPackage = ServicesPackage.eINSTANCE;
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    public Object doSwitch(EObject theEObject) {
        return doSwitch(theEObject.eClass(), theEObject);
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    protected Object doSwitch(EClass theEClass, EObject theEObject) {
        if (theEClass.eContainer() == modelPackage) {
            return doSwitch(theEClass.getClassifierID(), theEObject);
        }
        else {
            List eSuperTypes = theEClass.getESuperTypes();
            return
                eSuperTypes.isEmpty() ?
                    defaultCase(theEObject) :
                    doSwitch((EClass)eSuperTypes.get(0), theEObject);
        }
    }

    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    protected Object doSwitch(int classifierID, EObject theEObject) {
        switch (classifierID) {
            case ServicesPackage.COMPLEX_ARRAY_DATA_ARG: {
                ComplexArrayDataArg complexArrayDataArg = (ComplexArrayDataArg)theEObject;
                Object result = caseComplexArrayDataArg(complexArrayDataArg);
                if (result == null) result = caseDataArg(complexArrayDataArg);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.COMPLEX_DATA_ARG: {
                ComplexDataArg complexDataArg = (ComplexDataArg)theEObject;
                Object result = caseComplexDataArg(complexDataArg);
                if (result == null) result = caseDataArg(complexDataArg);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.DATA_ARG: {
                DataArg dataArg = (DataArg)theEObject;
                Object result = caseDataArg(dataArg);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.MESSAGE: {
                Message message = (Message)theEObject;
                Object result = caseMessage(message);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.PRIMITIVE_ARRAY_DATA_ARG: {
                PrimitiveArrayDataArg primitiveArrayDataArg = (PrimitiveArrayDataArg)theEObject;
                Object result = casePrimitiveArrayDataArg(primitiveArrayDataArg);
                if (result == null) result = caseDataArg(primitiveArrayDataArg);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.PRIMITIVE_DATA_ARG: {
                PrimitiveDataArg primitiveDataArg = (PrimitiveDataArg)theEObject;
                Object result = casePrimitiveDataArg(primitiveDataArg);
                if (result == null) result = caseDataArg(primitiveDataArg);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.REQUEST: {
                Request request = (Request)theEObject;
                Object result = caseRequest(request);
                if (result == null) result = caseMessage(request);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.RESPONSE: {
                Response response = (Response)theEObject;
                Object result = caseResponse(response);
                if (result == null) result = caseMessage(response);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.ESTRING_TO_EOBJECT_MAP_ENTRY: {
                Map.Entry eStringToEObjectMapEntry = (Map.Entry)theEObject;
                Object result = caseEStringToEObjectMapEntry(eStringToEObjectMapEntry);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.NULL_DATA_ARG: {
                NullDataArg nullDataArg = (NullDataArg)theEObject;
                Object result = caseNullDataArg(nullDataArg);
                if (result == null) result = caseDataArg(nullDataArg);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ServicesPackage.OBJECT_ARRAY_DATA_ARG: {
                ObjectArrayDataArg objectArrayDataArg = (ObjectArrayDataArg)theEObject;
                Object result = caseObjectArrayDataArg(objectArrayDataArg);
                if (result == null) result = caseDataArg(objectArrayDataArg);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            default: return defaultCase(theEObject);
        }
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Complex Array Data Arg</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Complex Array Data Arg</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseComplexArrayDataArg(ComplexArrayDataArg object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Complex Data Arg</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Complex Data Arg</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseComplexDataArg(ComplexDataArg object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Data Arg</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Data Arg</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseDataArg(DataArg object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Message</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Message</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseMessage(Message object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Primitive Array Data Arg</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Primitive Array Data Arg</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object casePrimitiveArrayDataArg(PrimitiveArrayDataArg object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Primitive Data Arg</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Primitive Data Arg</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object casePrimitiveDataArg(PrimitiveDataArg object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Request</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Request</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseRequest(Request object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Response</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Response</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseResponse(Response object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>EString To EObject Map Entry</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EString To EObject Map Entry</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseEStringToEObjectMapEntry(Map.Entry object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Null Data Arg</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Null Data Arg</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseNullDataArg(NullDataArg object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>Object Array Data Arg</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>Object Array Data Arg</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public Object caseObjectArrayDataArg(ObjectArrayDataArg object) {
        return null;
    }

    /**
     * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc -->
     * This implementation returns null;
     * returning a non-null result will terminate the switch, but this is the last case anyway.
     * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    public Object defaultCase(EObject object) {
        return null;
    }

} //ServicesSwitch
