/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

import com.ibm.team.repository.common.Location;
import com.ibm.team.repository.common.TeamRepositoryException;
import com.ibm.team.repository.common.internal.IFeedService;
import com.ibm.team.repository.common.transport.LenientCertificateValidator;
import com.ibm.team.repository.common.transport.TeamServiceException;
import com.ibm.team.repository.transport.client.ITeamRestServiceClient.IRestClientConnection;
import com.ibm.team.repository.transport.client.ITeamRestServiceClient.IRestClientConnection.Response;

public class Bug59963 {
	
	public static void main(String[] args) {
		
		String repositoryUri= "https://localhost:9443/jazz/"; //$NON-NLS-1$
		String path= ""; //$NON-NLS-1$
		String query= "provider=team&project_area=JUnit+Project&project_area_id=_MSttQINDEd2XRdRqHzVb-w"; //$NON-NLS-1$
		
		Location location= Location.serviceLocation(repositoryUri, IFeedService.class, path, query);
		RemoteTeamServer server= new RemoteTeamServer(repositoryUri, LenientCertificateValidator.INSTANCE);
		server.setCredentials("ADMIN", "ADMIN"); //$NON-NLS-1$ //$NON-NLS-2$
		
		TeamRestServiceClient client= new TeamRestServiceClient(server, IFeedService.class, null);
		
		IRestClientConnection connection= client.getConnection(location);
		
		Response response;
		try {
			response= connection.doGet();
			InputStream inStream= response.getResponseStream();
			DocumentBuilder builder= DocumentBuilderFactory.newInstance().newDocumentBuilder();
			Document document= builder.parse(inStream);
			
			Transformer transformer= TransformerFactory.newInstance().newTransformer();
			transformer.transform(new DOMSource(document), new StreamResult(System.out));
			
		} catch (TeamServiceException e) {
			e.printStackTrace();
		} catch (TeamRepositoryException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (TransformerException e) {
			e.printStackTrace();
		}
	}
}
