/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import com.ibm.team.repository.common.PermissionDeniedException;

/**
 * This Exception is a specialization indicating that the RemoteTeamServer is trying access a server with a client certificate, but the 
 * target server is unable to accept it (it could mean the client certificate is not valid, but it could also imply the server is not configured
 * to accept any client certificates)
 */
public class ClientCertificateNotAcceptedException extends AuthenticationException {

    private static final long serialVersionUID = 440901706967931044L;

    public ClientCertificateNotAcceptedException(String message, int statusCode) {
        super(message, new PermissionDeniedException(message), statusCode);
    }

    public ClientCertificateNotAcceptedException(String message) {
        super(message, new PermissionDeniedException(message));
    }
}
