/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.transport.client;

/**
 * Internal extension of {@link ITeamRawRestServiceClient} for the purpose of
 * adding an OAuth handler.
 * @since 0.7
 */
public interface IInternalRawRestServiceClient extends ITeamRawRestServiceClient {
    
    /**
     * Sets the IOAuthHandler associated with this instance.  This association
     * only affects new connections created since the handler is set.
     * 
     * @param oauthHandler The handler to associate to this service.  May be
     * <code>null</code>.
     * 
     * @return The handler this was replaced.  May be <code>null</code>.
     */
    public IOAuthHandler setOAuthHandler(IOAuthHandler oauthHandler);

}
