/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.transport.client;

/**
 * An interface describing an OAuth request token and secret, as referenced
 * by {@link OAuthHandler}.
 * 
 * @DoImplement Clients may implement this interface to provide their own
 *  login info.
 * @since 0.7
 */
public interface IOAuthRequestTokenInfo {

    /**
     * Returns the request token for an OAuth request.
     * @return The request token. Must not be <code>null</code>.
     */
    public String getRequestToken();

    /**
     * Returns the token secret for an OAuth request.
     * @return The request token. Must not be <code>null</code>.
     */
    public String getTokenSecret();
}
