/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import com.ibm.team.repository.common.PermissionDeniedException;

/**
 * This Exception is a specialization indicating that the RemoteTeamServer is trying access a server with insufficient access rights (aka 403)
 */
public class InsufficientRightsException extends AuthenticationException {

    private static final long serialVersionUID = 244806931534771456L;

    public InsufficientRightsException(String message, int statusCode) {
        super(message, new PermissionDeniedException(message), statusCode);
    }

    public InsufficientRightsException(String message) {
        super(message, new PermissionDeniedException(message));
    }
}
