/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import com.ibm.team.repository.common.PermissionDeniedException;

/**
 * This Exception is a specialization indicating that the RemoteTeamServer is trying access a server with an invalid client certificate
 */
public class InvalidCertificateOrSmartcardException extends AuthenticationException {

    private static final long serialVersionUID = 2295561198549847130L;

    public InvalidCertificateOrSmartcardException(String message, Throwable e) {
        super(message, new PermissionDeniedException(message, e));
    }

    public InvalidCertificateOrSmartcardException(String message) {
        super(message, new PermissionDeniedException(message));
    }
}
