/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import com.ibm.team.repository.common.PermissionDeniedException;

/**
 * This Exception is a specialization indicating that the RemoteTeamServer is trying access a server with an invalid (or expired) Kerberos ticket
 */
public class KerberosInvalidTicketException extends AuthenticationException {

    private static final long serialVersionUID = 440901706967931044L;

    public KerberosInvalidTicketException(String message, int statusCode) {
        super(message, new PermissionDeniedException(message), statusCode);
    }

    public KerberosInvalidTicketException(String message) {
        super(message, new PermissionDeniedException(message));
    }

}
