/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import com.ibm.team.repository.common.PermissionDeniedException;

/**
 * This Exception is a specialization indicating that the RemoteTeamServer is trying access a server with a Kerberos/SPNEGO connection even though the target
 * server is not configured as such
 */
public class NoKerberosTargetException extends AuthenticationException {

    private static final long serialVersionUID = -152825880748721570L;

    public NoKerberosTargetException(String message, int statusCode) {
        super(message, new PermissionDeniedException(message), statusCode);
    }

    public NoKerberosTargetException(String message) {
        super(message, new PermissionDeniedException(message));
    }

}
