/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import java.lang.reflect.Method;

import com.ibm.team.repository.common.transport.ITeamServer;
import com.ibm.team.repository.common.transport.ITeamService;

/**
 *
 */
public class RemoteTeamRestService implements ITeamService {

	private RemoteTeamServer      remoteTeamServer;
	private ClassLoader           classLoader;
	private Class                 serviceClass;
	private String				  version;
	private TeamRestServiceClient implementation;
	
	/**
	 *
	 */
	public RemoteTeamRestService(RemoteTeamServer remoteTeamServer, Class serviceClass, ClassLoader classLoader, String version) {
		super();
		
		this.remoteTeamServer = remoteTeamServer;
		this.classLoader      = classLoader;
		this.serviceClass     = serviceClass;
		this.version 		  = version;
		implementation = new TeamRestServiceClient(remoteTeamServer, serviceClass, classLoader);

	}
	
	/**
	 *
	 */
	public ITeamServer getServer() {
		return remoteTeamServer;
	}

	public String getVersion() {
		return version;
	}
	
	/**
	 *
	 */
	public ClassLoader getServiceClassLoader() {
		return classLoader;
	}

	/**
	 *
	 */
	public Class getServiceClass() {
		return serviceClass;
	}

	/**
	 *
	 */
	public Object getImplementation() {
		return implementation;
	}

	/**
	 *
	 */
	public boolean isLocal() {
		return false;
	}

	/**
	 *
	 */
	public Method getMethod(String name) {
		throw new IllegalStateException();
	}

	/**
	 *
	 */
	public Object invoke(Object proxy, Method method, Object[] arguments) throws Throwable {
		throw new IllegalStateException();
	}

}
