/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.team.repository.transport.client;

import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;

/**
 * @since 2.0.0.2 iFix 1
 */
public class SSLContextUtil {

	/**
	 * @since 2.0.0.2 iFix 1
	 */
    public static final String SSL_TLS = "SSL_TLS"; //$NON-NLS-1$
    /**
	 * @since 2.0.0.2 iFix 1
	 */
    public static final String TLS = "TLS"; //$NON-NLS-1$
    /**
	 * @since 2.0.0.2 iFix 1
	 */
    public static final String SSL = "SSL"; //$NON-NLS-1$
	
	/**
	 * Creates an SSL context factory.
	 * The returned SSLContext will be created so that it is compatible with the
	 * current security environment.  If a FIPS environment is detected then a
	 * FIPS 140-2 complaint context will be returned. 
	 * 
	 * @return a {@link SSLContext}
	 * @since 2.0.0.2 iFix 1
	 */
	public static SSLContext createSSLContext(TrustManager trustManager) {
       return createSSLContext(null, trustManager);
    }
	/**
	 * Creates an SSL context factory.
	 * The returned SSLContext will be created so that it is compatible with the
	 * current security environment.  If a FIPS environment is detected then a
	 * FIPS 140-2 complaint context will be returned. 
	 * 
	 * @return a {@link SSLContext}
	 * @since 3.0
	 */
	public static SSLContext createSSLContext(KeyManager[] keyManagers, TrustManager trustManager) {
	    return SSLUtils.createSSLContext(keyManagers, trustManager);
	}
	    
}
