/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
/*
 *
 */
package com.ibm.team.repository.transport.client;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

import com.ibm.team.repository.common.transport.ITeamService;

/**
 *
 */
class ServiceInvocationHandler implements InvocationHandler {
	
	static private Object[] NoArgs = new Object[0];
	
	private ITeamService service;

	/**
	 *
	 */
	ServiceInvocationHandler(ITeamService service) {
		super();
		
		this.service = service;
	}
	
	/**
	 * 
	 */
	public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
		if (null == args) args = NoArgs;
		
		Object result = service.invoke(proxy, method, args);
		
		return result;
	}

}
