/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

package com.ibm.team.repository.transport.client;

import com.ibm.team.repository.transport.auth.TransportAuthUtil;

/**
 * An exception specific to the {@link TransportAuthUtil} class.  This
 * exception exists distinct from all other repository exceptions in that it
 * is not derived from those exceptions, thus minimizing dependencies on this
 * class and {@link TransportAuthUtil}.
 */
public class TransportAuthException extends Exception {

    private static final long serialVersionUID = 5228299590293391290L;

    /**
     * Constructs an instance of this class with the specified detail message.
     * 
     * @param message The message for this exception.  May be <code>null</code>.
     */
    public TransportAuthException(String message) {
        super(message);
    }

    /**
     * Constructs an instance of this class with the specified message and
     * cause. 
     * 
     * @param message The message for this exception.  May be <code>null</code>.
     * @param cause The optional underlying cause for this exception. May be
     * <code>null</code>.
     */
    public TransportAuthException(String message, Throwable cause) {
        super(message, cause);
    }   
}
