/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package org.xmlsoap.schemas.soap.envelope;

import org.eclipse.emf.ecore.EObject;

import com.ibm.team.repository.common.transport.internal.services.Request;
import com.ibm.team.repository.common.transport.internal.services.Response;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Body</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Body#getFault <em>Fault</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Body#getRequest <em>Request</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Body#getResponse <em>Response</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getBody()
 * @model extendedMetaData="name='Body' kind='elementOnly'"
 * @generated
 */
public interface Body extends EObject {
    /**
     * Returns the value of the '<em><b>Fault</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Fault</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Fault</em>' containment reference.
     * @see #setFault(Fault)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getBody_Fault()
     * @model containment="true"
     *        extendedMetaData="kind='element' name='Fault' namespace='##targetNamespace'"
     * @generated
     */
    Fault getFault();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Body#getFault <em>Fault</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Fault</em>' containment reference.
     * @see #getFault()
     * @generated
     */
    void setFault(Fault value);

    /**
     * Returns the value of the '<em><b>Request</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Request</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Request</em>' containment reference.
     * @see #setRequest(Request)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getBody_Request()
     * @model containment="true"
     *        extendedMetaData="kind='element' name='Request'"
     * @generated
     */
    Request getRequest();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Body#getRequest <em>Request</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Request</em>' containment reference.
     * @see #getRequest()
     * @generated
     */
    void setRequest(Request value);

    /**
     * Returns the value of the '<em><b>Response</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Response</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Response</em>' containment reference.
     * @see #setResponse(Response)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getBody_Response()
     * @model containment="true"
     *        extendedMetaData="kind='element' name='Response'"
     * @generated
     */
    Response getResponse();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Body#getResponse <em>Response</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Response</em>' containment reference.
     * @see #getResponse()
     * @generated
     */
    void setResponse(Response value);

} // Body
