/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package org.xmlsoap.schemas.soap.envelope;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.FeatureMap;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Envelope</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Envelope#getHeader <em>Header</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Envelope#getBody <em>Body</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Envelope#getAnyAttribute <em>Any Attribute</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getEnvelope()
 * @model extendedMetaData="name='Envelope' kind='elementOnly'"
 * @generated
 */
public interface Envelope extends EObject {
    /**
     * Returns the value of the '<em><b>Header</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Header</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Header</em>' containment reference.
     * @see #setHeader(Header)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getEnvelope_Header()
     * @model containment="true"
     *        extendedMetaData="kind='element' name='Header' namespace='##targetNamespace'"
     * @generated
     */
    Header getHeader();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Envelope#getHeader <em>Header</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Header</em>' containment reference.
     * @see #getHeader()
     * @generated
     */
    void setHeader(Header value);

    /**
     * Returns the value of the '<em><b>Body</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Body</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Body</em>' containment reference.
     * @see #setBody(Body)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getEnvelope_Body()
     * @model containment="true" required="true"
     *        extendedMetaData="kind='element' name='Body' namespace='##targetNamespace'"
     * @generated
     */
    Body getBody();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Envelope#getBody <em>Body</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Body</em>' containment reference.
     * @see #getBody()
     * @generated
     */
    void setBody(Body value);

    /**
     * Returns the value of the '<em><b>Any Attribute</b></em>' attribute list.
     * The list contents are of type {@link org.eclipse.emf.ecore.util.FeatureMap.Entry}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Any Attribute</em>' attribute list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Any Attribute</em>' attribute list.
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getEnvelope_AnyAttribute()
     * @model unique="false" dataType="org.eclipse.emf.ecore.EFeatureMapEntry" many="true"
     *        extendedMetaData="kind='attributeWildcard' wildcards='##other' name=':2' processing='lax'"
     * @generated
     */
    FeatureMap getAnyAttribute();

} // Envelope
