/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package org.xmlsoap.schemas.soap.envelope;

import javax.xml.namespace.QName;

import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Fault</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * 				Fault reporting structure
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Fault#getFaultcode <em>Faultcode</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Fault#getFaultstring <em>Faultstring</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Fault#getDetail <em>Detail</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.Fault#getExtraData <em>Extra Data</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getFault()
 * @model extendedMetaData="name='Fault' kind='elementOnly'"
 * @generated
 */
public interface Fault extends EObject {
    /**
     * Returns the value of the '<em><b>Faultcode</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Faultcode</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Faultcode</em>' attribute.
     * @see #setFaultcode(QName)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getFault_Faultcode()
     * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.QName" required="true"
     *        extendedMetaData="kind='element' name='faultcode'"
     * @generated
     */
    QName getFaultcode();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Fault#getFaultcode <em>Faultcode</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Faultcode</em>' attribute.
     * @see #getFaultcode()
     * @generated
     */
    void setFaultcode(QName value);

    /**
     * Returns the value of the '<em><b>Faultstring</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Faultstring</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Faultstring</em>' attribute.
     * @see #setFaultstring(String)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getFault_Faultstring()
     * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
     *        extendedMetaData="kind='element' name='faultstring'"
     * @generated
     */
    String getFaultstring();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Fault#getFaultstring <em>Faultstring</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Faultstring</em>' attribute.
     * @see #getFaultstring()
     * @generated
     */
    void setFaultstring(String value);

    /**
     * Returns the value of the '<em><b>Detail</b></em>' containment reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Detail</em>' containment reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Detail</em>' containment reference.
     * @see #setDetail(Detail)
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getFault_Detail()
     * @model containment="true"
     *        extendedMetaData="kind='element' name='detail'"
     * @generated
     */
    Detail getDetail();

    /**
     * Sets the value of the '{@link org.xmlsoap.schemas.soap.envelope.Fault#getDetail <em>Detail</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Detail</em>' containment reference.
     * @see #getDetail()
     * @generated
     */
    void setDetail(Detail value);

    /**
     * Returns the value of the '<em><b>Extra Data</b></em>' map.
     * The key is of type {@link java.lang.String},
     * and the value is of type {@link org.eclipse.emf.ecore.EObject},
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Extra Data</em>' map isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Extra Data</em>' map.
     * @see org.xmlsoap.schemas.soap.envelope.EnvelopePackage#getFault_ExtraData()
     * @model mapType="com.ibm.team.repository.common.transport.internal.services.EStringToEObjectMapEntry<org.eclipse.emf.ecore.EString, org.eclipse.emf.ecore.EObject>" ordered="false"
     *        extendedMetaData="kind='element' name='detail'"
     * @generated
     */
    EMap<String, EObject> getExtraData();

} // Fault
