/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package org.xmlsoap.schemas.soap.envelope.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.emf.ecore.xml.type.XMLTypeFactory;
import org.eclipse.emf.ecore.xml.type.XMLTypePackage;
import org.xmlsoap.schemas.soap.envelope.Body;
import org.xmlsoap.schemas.soap.envelope.Detail;
import org.xmlsoap.schemas.soap.envelope.DocumentRoot;
import org.xmlsoap.schemas.soap.envelope.Envelope;
import org.xmlsoap.schemas.soap.envelope.EnvelopeFactory;
import org.xmlsoap.schemas.soap.envelope.EnvelopePackage;
import org.xmlsoap.schemas.soap.envelope.Fault;
import org.xmlsoap.schemas.soap.envelope.Header;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class EnvelopeFactoryImpl extends EFactoryImpl implements EnvelopeFactory {
    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static EnvelopeFactory init() {
        try {
            EnvelopeFactory theEnvelopeFactory = (EnvelopeFactory)EPackage.Registry.INSTANCE.getEFactory("http://schemas.xmlsoap.org/soap/envelope/");  //$NON-NLS-1$
            if (theEnvelopeFactory != null) {
                return theEnvelopeFactory;
            }
        }
        catch (Exception exception) {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new EnvelopeFactoryImpl();
    }

    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EnvelopeFactoryImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EObject create(EClass eClass) {
        switch (eClass.getClassifierID()) {
            case EnvelopePackage.BODY: return createBody();
            case EnvelopePackage.DETAIL: return createDetail();
            case EnvelopePackage.DOCUMENT_ROOT: return createDocumentRoot();
            case EnvelopePackage.ENVELOPE: return createEnvelope();
            case EnvelopePackage.FAULT: return createFault();
            case EnvelopePackage.HEADER: return createHeader();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object createFromString(EDataType eDataType, String initialValue) {
        switch (eDataType.getClassifierID()) {
            case EnvelopePackage.ENCODING_STYLE:
                return createEncodingStyleFromString(eDataType, initialValue);
            case EnvelopePackage.MUST_UNDERSTAND_TYPE:
                return createMustUnderstandTypeFromString(eDataType, initialValue);
            case EnvelopePackage.MUST_UNDERSTAND_TYPE_OBJECT:
                return createMustUnderstandTypeObjectFromString(eDataType, initialValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String convertToString(EDataType eDataType, Object instanceValue) {
        switch (eDataType.getClassifierID()) {
            case EnvelopePackage.ENCODING_STYLE:
                return convertEncodingStyleToString(eDataType, instanceValue);
            case EnvelopePackage.MUST_UNDERSTAND_TYPE:
                return convertMustUnderstandTypeToString(eDataType, instanceValue);
            case EnvelopePackage.MUST_UNDERSTAND_TYPE_OBJECT:
                return convertMustUnderstandTypeObjectToString(eDataType, instanceValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Body createBody() {
        BodyImpl body = new BodyImpl();
        return body;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Detail createDetail() {
        DetailImpl detail = new DetailImpl();
        return detail;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public DocumentRoot createDocumentRoot() {
        DocumentRootImpl documentRoot = new DocumentRootImpl();
        return documentRoot;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Envelope createEnvelope() {
        EnvelopeImpl envelope = new EnvelopeImpl();
        return envelope;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Fault createFault() {
        FaultImpl fault = new FaultImpl();
        return fault;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Header createHeader() {
        HeaderImpl header = new HeaderImpl();
        return header;
    }

    /**
     * <!-- begin-user-doc -->
     * @param eDataType 
     * <!-- end-user-doc -->
     * @generated
     */
    public List<String> createEncodingStyleFromString(EDataType eDataType, String initialValue) {
        if (initialValue == null) return null;
        List<String> result = new ArrayList<String>();
        for (StringTokenizer stringTokenizer = new StringTokenizer(initialValue); stringTokenizer.hasMoreTokens(); ) {
            String item = stringTokenizer.nextToken();
            result.add((String)XMLTypeFactory.eINSTANCE.createFromString(XMLTypePackage.Literals.ANY_URI, item));
        }
        return result;
    }

    /**
     * <!-- begin-user-doc -->
     * @param eDataType 
     * <!-- end-user-doc -->
     * @generated
     */
    public String convertEncodingStyleToString(EDataType eDataType, Object instanceValue) {
        if (instanceValue == null) return null;
        List<?> list = (List<?>)instanceValue;
        if (list.isEmpty()) return ""; //$NON-NLS-1$
        StringBuffer result = new StringBuffer();
        for (Object item : list) {
            result.append(XMLTypeFactory.eINSTANCE.convertToString(XMLTypePackage.Literals.ANY_URI, item));
            result.append(' ');
        }
        return result.substring(0, result.length() - 1);
    }

    /**
     * <!-- begin-user-doc -->
     * @param eDataType 
     * <!-- end-user-doc -->
     * @generated
     */
    public Boolean createMustUnderstandTypeFromString(EDataType eDataType, String initialValue) {
        return (Boolean)XMLTypeFactory.eINSTANCE.createFromString(XMLTypePackage.Literals.BOOLEAN, initialValue);
    }

    /**
     * <!-- begin-user-doc -->
     * @param eDataType 
     * <!-- end-user-doc -->
     * @generated
     */
    public String convertMustUnderstandTypeToString(EDataType eDataType, Object instanceValue) {
        return XMLTypeFactory.eINSTANCE.convertToString(XMLTypePackage.Literals.BOOLEAN, instanceValue);
    }

    /**
     * <!-- begin-user-doc -->
     * @param eDataType 
     * <!-- end-user-doc -->
     * @generated not
     */
    public Boolean createMustUnderstandTypeObjectFromString(EDataType eDataType, String initialValue) {
        return createMustUnderstandTypeFromString(EnvelopePackage.Literals.MUST_UNDERSTAND_TYPE, initialValue);
    }

    /**
     * <!-- begin-user-doc -->
     * @param eDataType 
     * <!-- end-user-doc -->
     * @generated
     */
    public String convertMustUnderstandTypeObjectToString(EDataType eDataType, Object instanceValue) {
        return convertMustUnderstandTypeToString(EnvelopePackage.Literals.MUST_UNDERSTAND_TYPE, instanceValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EnvelopePackage getEnvelopePackage() {
        return (EnvelopePackage)getEPackage();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
    @Deprecated
    public static EnvelopePackage getPackage() {
        return EnvelopePackage.eINSTANCE;
    }

} //EnvelopeFactoryImpl
