/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
package org.xmlsoap.schemas.soap.envelope.impl;

import javax.xml.namespace.QName;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreEMap;
import org.eclipse.emf.ecore.util.InternalEList;
import org.xmlsoap.schemas.soap.envelope.Detail;
import org.xmlsoap.schemas.soap.envelope.EnvelopePackage;
import org.xmlsoap.schemas.soap.envelope.Fault;

import com.ibm.team.repository.common.transport.internal.services.ServicesPackage;
import com.ibm.team.repository.common.transport.internal.services.impl.EStringToEObjectMapEntryImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Fault</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.impl.FaultImpl#getFaultcode <em>Faultcode</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.impl.FaultImpl#getFaultstring <em>Faultstring</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.impl.FaultImpl#getDetail <em>Detail</em>}</li>
 *   <li>{@link org.xmlsoap.schemas.soap.envelope.impl.FaultImpl#getExtraData <em>Extra Data</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FaultImpl extends EObjectImpl implements Fault {
    /**
     * The default value of the '{@link #getFaultcode() <em>Faultcode</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFaultcode()
     * @generated
     * @ordered
     */
    protected static final QName FAULTCODE_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getFaultcode() <em>Faultcode</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFaultcode()
     * @generated
     * @ordered
     */
    protected QName faultcode = FAULTCODE_EDEFAULT;

    /**
     * The default value of the '{@link #getFaultstring() <em>Faultstring</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFaultstring()
     * @generated
     * @ordered
     */
    protected static final String FAULTSTRING_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getFaultstring() <em>Faultstring</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getFaultstring()
     * @generated
     * @ordered
     */
    protected String faultstring = FAULTSTRING_EDEFAULT;

    /**
     * The cached value of the '{@link #getDetail() <em>Detail</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDetail()
     * @generated
     * @ordered
     */
    protected Detail detail;

    /**
     * The cached value of the '{@link #getExtraData() <em>Extra Data</em>}' map.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getExtraData()
     * @generated
     * @ordered
     */
    protected EMap<String, EObject> extraData;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FaultImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return EnvelopePackage.Literals.FAULT;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public QName getFaultcode() {
        return faultcode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setFaultcode(QName newFaultcode) {
        QName oldFaultcode = faultcode;
        faultcode = newFaultcode;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, EnvelopePackage.FAULT__FAULTCODE, oldFaultcode, faultcode));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String getFaultstring() {
        return faultstring;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setFaultstring(String newFaultstring) {
        String oldFaultstring = faultstring;
        faultstring = newFaultstring;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, EnvelopePackage.FAULT__FAULTSTRING, oldFaultstring, faultstring));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public Detail getDetail() {
        return detail;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetDetail(Detail newDetail, NotificationChain msgs) {
        Detail oldDetail = detail;
        detail = newDetail;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EnvelopePackage.FAULT__DETAIL, oldDetail, newDetail);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setDetail(Detail newDetail) {
        if (newDetail != detail) {
            NotificationChain msgs = null;
            if (detail != null)
                msgs = ((InternalEObject)detail).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EnvelopePackage.FAULT__DETAIL, null, msgs);
            if (newDetail != null)
                msgs = ((InternalEObject)newDetail).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EnvelopePackage.FAULT__DETAIL, null, msgs);
            msgs = basicSetDetail(newDetail, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, EnvelopePackage.FAULT__DETAIL, newDetail, newDetail));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EMap<String, EObject> getExtraData() {
        if (extraData == null) {
            extraData = new EcoreEMap<String,EObject>(ServicesPackage.Literals.ESTRING_TO_EOBJECT_MAP_ENTRY, EStringToEObjectMapEntryImpl.class, this, EnvelopePackage.FAULT__EXTRA_DATA);
        }
        return extraData;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case EnvelopePackage.FAULT__DETAIL:
                return basicSetDetail(null, msgs);
            case EnvelopePackage.FAULT__EXTRA_DATA:
                return ((InternalEList<?>)getExtraData()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case EnvelopePackage.FAULT__FAULTCODE:
                return getFaultcode();
            case EnvelopePackage.FAULT__FAULTSTRING:
                return getFaultstring();
            case EnvelopePackage.FAULT__DETAIL:
                return getDetail();
            case EnvelopePackage.FAULT__EXTRA_DATA:
                if (coreType) return getExtraData();
                else return getExtraData().map();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case EnvelopePackage.FAULT__FAULTCODE:
                setFaultcode((QName)newValue);
                return;
            case EnvelopePackage.FAULT__FAULTSTRING:
                setFaultstring((String)newValue);
                return;
            case EnvelopePackage.FAULT__DETAIL:
                setDetail((Detail)newValue);
                return;
            case EnvelopePackage.FAULT__EXTRA_DATA:
                ((EStructuralFeature.Setting)getExtraData()).set(newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case EnvelopePackage.FAULT__FAULTCODE:
                setFaultcode(FAULTCODE_EDEFAULT);
                return;
            case EnvelopePackage.FAULT__FAULTSTRING:
                setFaultstring(FAULTSTRING_EDEFAULT);
                return;
            case EnvelopePackage.FAULT__DETAIL:
                setDetail((Detail)null);
                return;
            case EnvelopePackage.FAULT__EXTRA_DATA:
                getExtraData().clear();
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case EnvelopePackage.FAULT__FAULTCODE:
                return FAULTCODE_EDEFAULT == null ? faultcode != null : !FAULTCODE_EDEFAULT.equals(faultcode);
            case EnvelopePackage.FAULT__FAULTSTRING:
                return FAULTSTRING_EDEFAULT == null ? faultstring != null : !FAULTSTRING_EDEFAULT.equals(faultstring);
            case EnvelopePackage.FAULT__DETAIL:
                return detail != null;
            case EnvelopePackage.FAULT__EXTRA_DATA:
                return extraData != null && !extraData.isEmpty();
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (faultcode: "); //$NON-NLS-1$
        result.append(faultcode);
        result.append(", faultstring: "); //$NON-NLS-1$
        result.append(faultstring);
        result.append(')');
        return result.toString();
    }

} //FaultImpl
